<?
	/**
	 *	Title: Classe Boletus, model per a un grup de bolets.
	 *
	 *	Project: iBoletus
	 *	Author: Víctor Llorente Vaquero
	 *	Date: 20/11/2013
	 *	Email: vllorente@uco.edu
	 **/

	class Boletus {
	
		private $boletus = array();		
		private $db = null;
		private $dbConn = null;
		
		public function __construct() {
			$this->db = new Database();
			$this->dbConn = $this->db->getDB();
		}
				
		public function getTotalBoletusFromDB() {
			try {
				$stmt = $this->dbConn->query("select count(*) from boletus");
				$row = $stmt->fetch();
			} catch (PDOException $e) { $this->db->getError($e); }

			return $row[0];		
		}
		
		public function getBoletusFromDB($order, $page) {
			$start = ($page - 1) * DISPLAY_RECORDS;

			// Ordre per defecte
			if (!isset($order)) $order = "order by bol_name";
			
			$stmt = $this->dbConn->query("select bol_id from boletus $order limit $start, ".DISPLAY_RECORDS);
			foreach ($stmt->fetchAll() as $boletu) {
				$bol = new Boletu($this->db);
				$bol->initWithId($boletu['bol_id']);
				$this->boletus[] = $bol;
			}
		}
		
		public function getAllBoletusFromDB($value = "") {
			$result = array();
			
			$stmt = $this->dbConn->prepare("select bol_id as id, bol_name as description from boletus where bol_toxic = 1 and (bol_name like :value) order by bol_name, bol_name_latin");
			$stmt->execute(array('value' => '%'.$value.'%'));
			
			foreach ($stmt->fetchAll() as $bol) array_push($result, $bol);
			
			return $result;
		}
		
		public function getBoletus() { return $this->boletus; }
	}
	
?>