<?

	class Content {
		
		private $support = null;
		private $security = null;
		private $redirect = null;
		private $detect = null;
		
		public function __construct() {
			$this->support = new Support();
			$this->security = new Security();
			$this->redirect = new Redirector();
			$this->detect = new MobileDetect();
		}
		
		/////////////////////
		// Gestió d'errors //
		/////////////////////
		
		public function getErrorPage($header, $text) {
			$this->getHeader(_($header));
			
			echo "<div class=\"center_content\">";
			echo "<div class=\"header\"><p class=\"header_text\">"._($header)."</p></div>";
			echo "<div class=\"info\" style=\"text-align: center\"><p>"._($text)."</p><p><a href=\"".WWWROOT."/modules/login/main.php\">"._("Tornar a la pàgina d'inici")."</a></p></div>";
			echo "</div>";
		}

		//////////////////////////
		// Gestió de formularis //
		//////////////////////////
		
		/*
		 * Function getDiv($caption, $content, $name, $mode, $type, $error, $value, $extra)
		 * $caption:	Títol del camp
		 * $content:	Contingut
		 * $name:		Nom que s'utilitzarà en el formulari
		 * $mode:		0 - View (VIEW_MODE)
		 *				1 - Edit/Create (EDIT_MODE)
		 * $type:		Tipus d'element a mostrar (select, text, radio…)
		 *				0 - Text
		 *				1 - Yes/No
		 *				2 - Desplegable amb un array com a content amb [0] = id, [1] = text a mostrar
		 *				3 - Data (Dia - Mes - Any) content amb [0] = dia, [1] = mes, [2] = any
		 *				4 - Textarea
		 *				5 - Data (Any)
		 *				6 - Password
		 *				7 - Multicheck amb un array com a content amb [0] = id, [1] = text a mostrar, value és un array amb els valors seleccionats
		 *				8 - Nombre decimal (number_format)
		 * $error:		Codi d'error per mostrar els missatges corresponent. 
		 *				0 - No hi ha error.
		 * $value:		Camp que s'utilitza en els desplegables per assignar un valor seleccionar
		 * $extra:		Altra informació (p.e. javascript) que s'afegirà a l'HTML sense modificar
		 */
		
		public function getDiv($caption, $content, $name = "", $mode = 0, $type = 0, $error = 0, $value = "", $extra = "") {
			if ($name == "") $div_id = ""; else $div_id = "id=\"div-".$name."\"";
			
			if ($this->detect->isMobile() || $this->detect->isTablet()) { 
				/* Ignore tablets */
				$placeholder = "placeholder=\"".preg_replace('/\:/', '', $caption)."\"";
				$option = "<option value=\"-1\"> - ".preg_replace('/\:/', '', $caption)." - </option>";
				$size = "auto";
				$label_left = "label_left_mobile";
			} else { 
				/* normal and tablet */
				$label = "<label for=\"".$name."\" class=\"label_left\">"._($caption)."</label>";
				$option = "<option value=\"-1\">".INFO_CHOOSE_OPTION."</option>";
				$size = "50"; 
				$label_left = "label_left";
			}
			
			switch ($mode) {
				case VIEW_MODE: 
					switch ($type) {				
						case FIELD_TEXT:
							$div = "<div ".$div_id." class=\"section_entry\"><label class=\"label_left\">"._($caption)."</label><label class=\"label_left_aux\">".ht($content)."</label></div>";
							break;
						case FIELD_YES_NO:
							switch ($content) {
								case "0": $content = _("No");break;
								case "1": $content = _("Sí");break;
							}
							$div = "<div ".$div_id." class=\"section_entry\"><label class=\"label_left\">"._($caption)."</label><label>".ht($content)."</label></div>";
							break;
						case FIELD_TEXTAREA:
							$div = "<div ".$div_id." class=\"section_entry\"><label class=\"label_left\">"._($caption)."</label><label class=\"label_left_aux\">".nl2br(ht($content))."</label></div>";
							break;
						case FIELD_DECIMAL:
							// A $value hi ha el nombre de decimals
							$div = "<div ".$div_id." class=\"section_entry\"><label class=\"label_left\">"._($caption)."</label><label class=\"label_left_aux\">".nf(ht($content), $value)."</label></div>";
							break;
						case FIELD_PHOTO:
							$div = "<div ".$div_id." class=\"section_entry\"><figure><label class=\"label_left\">"._($caption)."</label><img class=\"photo\" src=\"".ht($content)."\" alt=\"".ht($extra)."\" /><figcaption><p>".ht($extra)."</p></figcaption></figure></div>";
							break;
						case FIELD_LINK:
							$div = "<div ".$div_id." class=\"section_entry\"><label class=\"label_left\">"._($caption)."</label><a href=\"".WWWROOT."/modules/".$extra."/view.php?id=".$value."\"><label class=\"label_left_aux\">".ht($content)."</label></a></div>";
							break;
					}
					break;
				case EDIT_MODE:
					switch ($type) {				
						case FIELD_TEXT:
							echo $extra;
							$input = "<input id=\"".$name."\" type=\"text\" name=\"".$name."\" size=\"".$size."\" maxlength=\"".MAX_INPUT."\" $placeholder value=\"".ht($content)."\" ".$extra." />";
							$div = "<div ".$div_id." class=\"section_entry\">".$label;
							if ($error != 0) { $div .= "<div class=\"div_input_error\">".$input."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
								} else { $div .= $input."</div>"; }
							break;
						case FIELD_YES_NO:
							($content) == 1 ? $yes = "checked" : $no = "checked";
							$input_yes = "<input class=\"no_border\" id=\"".$name."_yes\" type=\"radio\" name=\"".$name."\" value=\"1\" ".$yes." ".$extra." /><label>"._("Sí ".$caption)."</label>";
							$input_no = "<input class=\"no_border\" id=\"".$name."_no\" type=\"radio\" name=\"".$name."\" value=\"0\" ".$no." ".$extra." /><label>"._("No ".$caption)."</label>";
							$div = "<div ".$div_id." class=\"section_entry\"><label for=\"".$name."\" class=\"".$label_left."\"></label>".$input_yes.$input_no."</div>";
							break;
						case FIELD_SELECT:
							$select .= "<select id=\"".$name."\" name=\"".$name."\" ".$extra.">".$option;
							foreach($content as $c) {
								if ($value == "'".ht($c[0])."'" || $value == ht($c[0])) { 
									$select .= "<option selected value=\"".ht($c[0])."\">".ht($c[1])."</option>"; 
								} else { 
									$select .="<option value=\"".ht($c[0])."\">".ht($c[1])."</option>"; 
								} 
							} 
							$select .="</select>";
							$div = "<div ".$div_id." class=\"section_entry\">".$label;
							if ($error != 0) { $div .= "<div class=\"div_input_error\">".$select."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
							} else { $div .= $select."</div>"; }
							break;
						case FIELD_SELECT_SEARCH:
							$input = "<input id=\"input_search\" style=\"width: 138px\" type=\"text\" name=\"query\" size=\"20\" maxlength=\"50\" value=\"\"/> ";
							$select .= "<select id=\"".$name."\" style=\"width: 155px\" name=\"".$name."\"><option value=\"-1\">".INFO_CHOOSE_OPTION_MODULE."</option>"; 
							if (isset($content)) { 
								foreach($content as $row) {
									$show_module = false;
									if (!$this->security->hasPermission('list_users') && $row['sys_value'] == "users") $show_module = true;
									if ($row['sys_value'] == "positions") $show_module = true;
			 
									if ($mod == $row['sys_value']) { 
										if (!$show_module) $select .= "<option selected value=\"".$row['sys_value']."\">"._($row['sys_description'])."</option>"; 
									} else {
										if (!$show_module) $select .= "<option value=\"".$row['sys_value']."\">"._($row['sys_description'])."</option>";
									} 
								}
							} $select .= "</select>";
							$button = "<input title=\""._('Cercar')."\" class=\"button\" type=\"submit\" name=\"selected_action\" value=\""._('Cercar')."\">";
							$div = "<div ".$div_id.">".$input.$select.$button."</div>"; 
							break;
						case FIELD_DATE:
							$select_day = "<select id=\"day_".$name."\" name=\"day_".$name."\">".$this->getDaySelect(ht($content[0]))."</select>";
							$select_month = "<select id=\"month_".$name."\" name=\"month_".$name."\">".$this->getMonthSelect(ht($content[1]))."</select>";
							$select_year = "<select id=\"year_".$name."\" name=\"year_".$name."\">".$this->getYearSelect(ht($content[2]))."</select>";
	
							$div = "<div ".$div_id." class=\"section_entry\"><label for=\"".$name."\" class=\"label_left\">"._($caption)."</label>";
							if ($error != 0) { $div .= "<div class=\"div_input_error\">".$select_day.$select_month.$select_year."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
							} else { $div .= $select_day.$select_month.$select_year."</div>"; }
							break;
						case FIELD_TEXTAREA:
							$input = "<textarea cols=\"50\" id=\"".$name."\" name=\"".$name."\" maxlength=\"4096\" $placeholder>".ht($content)."</textarea>";
							$div = "<div ".$div_id." class=\"section_entry\">".$label;
							if ($error != 0) { $div .= "<div class=\"div_input_error\">".$input."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
								} else { $div .= $input."</div>"; }
							break;
						case FIELD_YEAR:
							$select_year = "<select id=\"".$name."\" name=\"".$name."\">".get_year_select(ht($content))."</select>";
	
							$div = "<div ".$div_id." class=\"section_entry\"><label for=\"".$name."\" class=\"label_left\">"._($caption)."</label>";
							if ($error != 0) { $div .= "<div class=\"div_input_error\">".$select_year."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
							} else { $div .= $select_year."</div>"; }
							break;
						case FIELD_PASSWORD:
							$input = "<input id=\"".$name."\" type=\"password\" name=\"".$name."\" size=\"".$size."\" maxlength=\"".MAX_INPUT."\" $placeholder value=\"".ht($content)."\" />";
							$div = "<div ".$div_id." class=\"section_entry\">".$label;
							if ($error != 0) { $div .= "<div class=\"div_input_error\">".$input."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
								} else { $div .= $input."</div>"; }
							break;
						case FIELD_CHECK:
							$div = "<div ".$div_id." class=\"section_entry\"><label for=\"".$name."\" class=\"label_left\">"._($caption)."</label>";
							if ($error == 0) $checkboxes = "<div class=\"div_input\">"; else $checkboxes = "<div>"; 
							foreach($content as $c) {
								if (!empty($value) && (in_array("'".ht($c[0])."'", $value) || in_array(ht($c[0]), $value))) { 
									$checkboxes .="<input checked type=\"checkbox\" name=\"".$name."[]\" value=\"".ht($c[0])."\">".ht($c[1])."</input><br>";
								} else {
									$checkboxes .="<input type=\"checkbox\" name=\"".$name."[]\" value=\"".ht($c[0])."\">".ht($c[1])."</input><br>";
								} 
							}
							$checkboxes .= "</div>";
							if ($error != 0) { $div .= "<div class=\"div_input_error\">".$checkboxes."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
								} else { $div .= $checkboxes."</div>"; }
							break;
						case FIELD_DECIMAL:
							$input = "<input id=\"".$name."\" type=\"text\" name=\"".$name."\" size=\"".$size."\" maxlength=\"".MAX_INPUT."\" value=\"".nf(ht($content), $value)."\" />";
							$div = "<div ".$div_id." class=\"section_entry\"><label for=\"".$name."\" class=\"label_left\">"._($caption)."</label>";
							if ($error != 0) { $div .= "<div class=\"div_input_error\">".$input."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
								} else { $div .= $input."</div>"; }
							break;
						case FIELD_PHOTO:
							$input = "<input id=\"".$name."\" title=\"Seleccionar fotografia\" type=\"file\" name=\"".$extra."\">";
							$div = "<div ".$div_id." class=\"section_entry\">".$label;
							if ($error != 0) { $div .= "<div class=\"div_input_error\">".$input."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
								} else { $div .= $input."</div>"; }
							break;
						case FIELD_EMAIL:
							$input = "<input id=\"".$name."\" type=\"email\" name=\"".$name."\" size=\"".$size."\" maxlength=\"".MAX_INPUT."\" placeholder=\"email@iboletus.com\" value=\"".ht($content)."\" />";
							$div = "<div ".$div_id." class=\"section_entry\">".$label;
							if ($error != 0) { $div .= "<div class=\"div_input_error\">".$input."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
								} else { $div .= $input."</div>"; }
							break;
					}
			}
	
			echo $div;
		}
		
		// Crear un input + select per al Ajax
		public function getAjaxDiv($caption, $module, $name = "", $button = "", $error = 0, $value = "", $extra = "") {
			if ($name == "") $div_id = ""; else $div_id = "id=\"div-".$name."\"";
			
			if ($this->detect->isMobile() && !$this->detect->isTablet()) { 
				/* Ignore tablets */
				$placeholder = "placeholder=\"".preg_replace('/\:/', '', $caption)."\"";
				$size = "auto";
			} else { 
				/* normal and tablet */
				$label = "<label for=\"".$name."\" class=\"label_left\">"._($caption)."</label>";
				$size = "50"; 
			}
			
			$content = array();
			
			// Segons el mòdul
			switch($module) {
				case "boletus":
					$boletus = new Boletus();
					$content = $boletus->getAllBoletusFromDB();
					break;
				default: exit; break;
			}
			
			$select = "<select name=\"combobox_".$name."_ajax\" ".$extra."><option value=\"-1\">".INFO_CHOOSE_OPTION."</option>";
			foreach ($content as $c) {
				if ($value == "'".ht($c[id])."'" || $value == ht($c[id])) {
					$select .= "<option selected value=\"".ht($c['id'])."\">".ht($c['description'])."</option>";
				} else {
					$select .= "<option value=\"".ht($c['id'])."\">".ht($c['description'])."</option>";
				} 
			}
			$select .="</select>";
			
			$input_text = "<input type=\"text\" id=\"search_".$name."\" name=\"search_".$name."\" size=\"30\" maxlength=\"".MAX_INPUT."\" $placeholder onkeyup=\"showResult(this.value, '".$module."', '".$name."')\" /> ";
			
			if (!empty($button)) $input_button = " <input title=\""._($button)."\" class=\"button\" type=\"submit\" name=\"selected_action\" value=\""._($button)."\" />";
			
			$div = "<div ".$div_id." class=\"section_entry\">".$label; 
			if ($error != 0) { $div .= "<div class=\"div_input_error\">".$input_text."<span id=\"combobox_".$name."\">".$select."</span>".$input_button."<label class=\"label_error\">".$this->getFieldErrorMessage($error)."</label></div></div>";
				} else { $div .= $input_text."<span id=\"combobox_".$name."\">".$select."</span>".$input_button."</div>"; }
			
			echo $div;
		}
			
		// A partir del codi retornat per la Classe Validator retorna la cadena a mostrar com a error als camps del formulari		
		public function getFieldErrorMessage($error_code) {
			switch ($error_code) {
				case INPUT_EMPTY: $msg = ERROR_EMPTY; break;
				case INPUT_INVALID: $msg = ERROR_REGEXP; break;
				case INPUT_REPEATED: $msg = ERROR_USER_REPEATED; break;
				default: $msg = "";
			}
		
			return $msg;
		}

		/* Function getDivConfirm($caption, $text, $yes_text, $no_text, $type)
		 * $type		0 - Delete
		 *				1 - Circulation
		 *				2 - Regular
		 */
		public function getDivConfirm($caption, $text, $yes_text, $no_text, $type) {
			switch ($type) {
				case CONFIRM_DELETE: $div_class = "content_confirm_delete"; $label = "label_error"; break;	
				case CONFIRM: $div_class = "content_confirm"; $label = "label_strong"; break;	
			}
	
			$div = "<div class=\"".$div_class."\">";
			$div .= "<label class=\"".$label."\">".$caption."</label>";	
			$div .= "<br><label>".$text."</label>";
			$div .= "<br><br><form class=\"global\" name=\"form_confirm\" accept-charset=\"UTF-8\" method=\"post\">";
			if ($yes_text != "") $div .= "<input title=\""._($yes_text)."\" class=\"button\" type=\"submit\" name=\"selected_action\" value=\""._($yes_text)."\">";
			if ($no_text != "") $div .= "<input title=\""._($no_text)."\" class=\"button\" type=\"submit\" name=\"selected_action\" value=\""._($no_text)."\">";
			$div .= "<input type=\"hidden\" name=\"action\" value=\"1\"/></form></div>";
	
			echo $div;
		}
		
		// Missatge que es mostra com a error (vermell) o informació (blau) per sobre un formulari
		public function getMessage($message, $error = 0) {
			($error) ? $class = "label_error" : $class = "label_info"; 
			return "<div class=\"info\"><label class=\"".$class."\">".$message."</label></div>";
		}

		// Funció per mostrar les capçaleres de les seccions d'un formulari
		public function getSectionHeader($title) {
			echo "<div class=\"section_entry\"><label class=\"label_header\">"._($title)."</label></div>";
		}
		
		// Funció per mostrar les subcapçaleres de les seccions d'un formulari
		public function getSubSectionHeader($title) {
			echo "<div class=\"section_entry\"><label class=\"label_sub_header\">"._($title)."</label></div>";
		}
		
		// Retorna un 'select' de Dia amb un dia seleccionat ($day) 
		public function getDaySelect($day) {
			$str = "<option value=\"0\">"._(" - Dia - ")."</option>";
			
			for ( $d = 1 ; $d <= 31 ; $d ++) {
				if ($day == $d) 
					$str .= "<option selected value=\"".$d."\">".$d."</option>";
				else 
					$str .= "<option value=\"".$d."\">".$d."</option>";
			}
			
			return $str;
		}
		
		// Retorna un 'select' de Mes amb un mes seleccionat ($month) 
		public function getMonthSelect($month) {
			$str = "<option value=\"0\">"._(" - Mes - ")."</option>";
			
			for ( $m = 1 ; $m <= 12 ; $m ++) {
				if ($month == $m)
					$str .= "<option selected value=\"".$m."\">".$m."</option>";
				else 
					$str .= "<option value=\"".$m."\">".$m."</option>";
			}
			
			return $str;
		}
		
		// Retorna un 'select' d'Any amb un any seleccionat ($year) 
		public function getYearSelect($year) {
			$str .= "<option value=\"0\">"._(" - Any - ")."</option>";
			
			for ( $y = date('Y')+YEARS_AHEAD ; $y >= 1902 ; $y --) {
				if ($year == $y)
					$str .= "<option selected value=\"".$y."\">".$y."</option>";
				else 
					$str .= "<option value=\"".$y."\">".$y."</option>";
			}
			
			return $str;
		}

		///////////////////////
		// Elements genèrics //
		///////////////////////
		
		// Funció que genera la capçalera per a totes les pàgines
		public function getHeader($title, $show = 0) {
			if ($_POST['switch_tabs']) {
				$disable_tabs = $_POST['disable_tabs'];
				if ($disable_tabs != $_COOKIE['disable_tabs']) {
					setcookie("disable_tabs", $disable_tabs, time() + 31536000, "/");
					
					$r = new Redirector();
					$r->selfRedirect();
				}
			}
	
			//echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">";
			echo "<!DOCTYPE html>";
			echo "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"".substr(LANG,0,2)."\">";
			echo "<head>";
			if ($this->detect->isMobile() || $this->detect->isTablet()) { 
				/* Ignore tablets */
				echo "<meta http-equiv=\"content-type;\" name=\"viewport\" content=\"width=device-width; initial-scale=1.0; maximum-scale=1.0; user-scalable=0;\" charset=\"utf-8\"/>";
				if ($this->detect->isMobile()) { echo "<link href=\"".WWWROOT."/style/".APP."_mobile.css\" rel=\"stylesheet\" media=\"screen and (min-device-width : 320px) and (max-device-width : 480px)\" />"; }
				if ($this->detect->isTablet()) { echo "<link href=\"".WWWROOT."/style/".APP."_mobile.css\" rel=\"stylesheet\" media=\"screen and (min-device-width : 768px) and (max-device-width : 1024px)\" />"; }
			} else {
				/* normal and tablet */
				echo "<meta content=\"text/html;\" http-equiv=\"content-type;\" charset=\"utf-8\">";
				echo "<link href=\"".WWWROOT."/style/".APP.".css\" rel=\"stylesheet\" media=\"screen\" />";
				echo "<link href=\"".WWWROOT."/images/favicon.ico\" rel=\"shortcut icon\">";
			}			
			if (preg_match('/(?i)msie [1-8]/',$_SERVER['HTTP_USER_AGENT'])) {
				// En cas que el navegador sigui InternetExplorer, incorporar el següent javascript per al HTML5
				echo "<script src=\"http://html5shim.googlecode.com/svn/trunk/html5.js\"></script>";
			}
			if ($show) {
				// Si el que es vol veure son els mapes, es necessari càrrega els javascripts corresponents
				echo "<script src=\"https://maps.googleapis.com/maps/api/js?sensor=false\"></script>";
				echo "<script src=\"http://geoxml3.googlecode.com/svn/branches/polys/geoxml3.js\"></script>";
			}
			echo "<title>".$title."</title>";
			echo "</head>";
			if ($show) {
				echo "<body onload=\"initialize()\">";
			} else {
				echo "<body>";
			}
	
			require_once(DIRROOT."/scripts/js/javascript.js");
			
			echo "<div class=\"center_content\">";
		}
	
		// Funció per mostrar la capçalera de totes les pàgines.
		public function getMainHeader($title_page) {
			
			$row_module = $this->support->getSearchModules();
			
			// Comprovar que té un paràmetre la variable de sessió 'modules'
			if (isset($_SESSION['return_to']['module'])) $mod = $_SESSION['return_to']['module'];
			
			if ($_POST['module_action']) {
				if ($_POST['list_modules'] == "-1") { 
					$this->redirect->redirect('login', 'main.php');
				} else {
					$this->redirect->redirect($_POST['list_modules'], 'main.php');
				}
			}
			
			$select = "<input id=\"input_search\" type=\"text\" name=\"query\" size=\"20\" maxlength=\"50\" value=\"\"/> ";
			$select .= "<select style=\"width: 155px\" name=\"sel_module\"><option value=\"-1\">".INFO_CHOOSE_OPTION_MODULE."</option>"; 
			if (isset($row_module)) { 
				foreach($row_module as $row) {
					$show_module = false;
					if (!$this->security->hasPermission('list_users') && $row['sys_value'] == "users") $show_module = true;
					if ($row['sys_value'] == "positions") $show_module = true;
					 
					if ($mod == $row['sys_value']) { 
						if (!$show_module) $select .= "<option selected value=\"".$row['sys_value']."\">"._($row['sys_description'])."</option>"; 
					} else {
						if (!$show_module) $select .= "<option value=\"".$row['sys_value']."\">"._($row['sys_description'])."</option>";
					} 
				} 
			} $select .= "</select><input title=\""._("Cercar")."\" type=\"image\" class=\"img_button\" src=\"".IMG_SEARCH."\" name=\"action_search\" value=\""._("Cercar")."\">";
	
			echo "<div>";
			echo "	<div class=\"main_header main_header_ts\">";
			if (($this->detect->isMobile() || $this->detect->isTablet()) && $this->security->isLogged()) { 
				echo "			<a href=\"".WWWROOT."/modules/login/logout.php\"><img style=\"float:right; margin-right: 5px\" title=\""._("Sortir de l'aplicació")."\" src=\"".IMG_BUTTON_EXIT."\"></a>";
				echo "			<a href=\"".WWWROOT."/modules/users/view.php?id=".$_SESSION['info_user']['id']."\"><img style=\"float:right; margin-right: 5px\" title=\""._("Modificar les dades personals")."\" src=\"".IMG_BUTTON_CONFIG."\"></a>";
				echo "			<a href=\"".WWWROOT."/modules/search/search_mobile.php\"><img style=\"float:right; margin-right: 5px\" title=\""._("Cercar")."\" src=\"".IMG_BUTTON_SEARCH."\"></a>";
			}
			echo "			<div>";
			echo "				<div class=\"main_header_title_position\">";
			if (!$this->detect->isMobile() && !$this->detect->isTablet() && $this->security->isLogged()) echo "<hgroup>";
			echo "						<span class=\"main_header_title\">"._(APP_NAME)."</span>";
			echo "						<br>";
			echo "						<span class=\"main_header_subtitle\">"._($title_page)."</span>";
			if (!$this->detect->isMobile() && !$this->detect->isTablet() && $this->security->isLogged()) echo "</hgroup>";
			echo "					<br>";
			echo "				</div>";
			echo "			</div>";
			if (!$this->detect->isMobile() && !$this->detect->isTablet() && $this->security->isLogged()) {
				echo "			<form name=\"form_search\" action=\"".WWWROOT."/modules/search/search.php\" accept-charset=\"UTF-8\" method=\"post\">";
				echo "				<div class=\"main_header_search\">";
				echo "					<label for=\"input_search\">"._("Cercar:")."</label>".$select;
				echo "					<input type=\"hidden\" name=\"action\" value=\"1\"/>";
				echo "				</div>";
				echo "			</form>";
			}
			echo "	</div>";
			
			if (!$this->detect->isMobile() && !$this->detect->isTablet() && $this->security->isLogged()) {
				echo "	<div class=\"main_header_tabs\">";
				echo "		<ul id=\"toptabs\">";  
				echo "			<li><a class=\"\" title=\""._("Bolets")."\" href=\"".WWWROOT."/modules/boletus/main.php\">"._("Bolets")."</a></li>";
				echo "			<li><a class=\"\" title=\""._("Localitzacions")."\" href=\"".WWWROOT."/modules/positions/main.php\">"._("Localitzacions")."</a></li>";
				echo "			<li><a class=\"\" title=\""._("Receptes")."\" href=\"".WWWROOT."/modules/recipes/main.php\">"._("Receptes")."</a></li>";
								if ($this->security->hasPermission('list_users')) echo "<li><a class=\"\" title=\""._("Usuaris")."\" href=\"".WWWROOT."/modules/users/main.php\">"._("Usuaris")."</a></li>";
				echo "		</ul>";
				echo "  	<div style=\"clear:both;\"></div>";
				echo "	</div>";
			}
			
			echo "</div>";
			
			// Mostrar el select quan es un dispositiu mòbil
			if (($this->detect->isMobile() || $this->detect->isTablet()) && $this->security->isLogged()) { $this->getSelectModule(); }
		}
		
		public function getSelectModule() {
			
			$row_module = $this->support->getSearchModules();
			
			// Comprovar que té un paràmetre la variable de sessió 'modules'
			if (isset($_SESSION['return_to']['module'])) $mod = $_SESSION['return_to']['module'];
			
			$select .= "<select id=\"list_modules\" onchange=\"this.form.submit()\" name=\"list_modules\"><option value=\"-1\">".INFO_CHOOSE_OPTION_MODULE."</option>";
			if (isset($row_module)) { 
				foreach($row_module as $row) {
					$show_module = false;
					if (!$this->security->hasPermission('list_users') && $row['sys_value'] == "users") $show_module = true;
					
					if ($mod == $row['sys_value']) {
						if (!$show_module) $select .= "<option selected value=\"".$row['sys_value']."\">"._($row['sys_description'])."</option>"; 
					} else { 
						if (!$show_module) $select .= "<option value=\"".$row['sys_value']."\">"._($row['sys_description'])."</option>";
					}
				} 
			} $select .= "</select><input type=\"hidden\" name=\"module_action\" value=\"1\"/>";
			
			echo "<form name=\"form_main\" accept-charset=\"UTF-8\" method=\"post\">".$select."</form>";
			 
		}
		
		// Funció que mostra el peu de pàgina
		public function getFooter() {
			if (!$this->detect->isMobile() && !$this->detect->isTablet()) {
				if ($this->security->isLogged()) { 
					$footer = "<div class=\"footer\">";
					$footer .= "<small>"._("Heu entrat com: ")."<a style=\"font-size:10px\" title=\""._("Modificar les dades personals")."\" href=\"".WWWROOT."/modules/users/view.php?id=".$_SESSION['info_user']['id']."\">".$_SESSION['info_user']['name']."</a>";
					$footer .= " (<a style=\"font-size:10px\" title=\""._("Sortir de l'aplicació")."\" href=\"".WWWROOT."/modules/login/logout.php\">"._("Sortir de l'aplicació")."</a>)</small>";
					$footer .= "</div>";
					echo $footer;
				}
				printf ("<footer><div class=\"footer\"><small>"._("%s, © 2012-%s. %s (v. %s rev. %s) funciona sobre programari lliure.<br/>Optimitzat navegadors Firefox 15+, Safari 5+, Chrome 8+ i Internet Explorer 9+")."</small></div></footer></div></body></html>", ORG, date('Y'), APP, version, revision);
			}
		}
	
		// Funció que mostra la navegació, per situar l'usuari o retornar més ràpidament a una pàgina anterior
		public function getNavigation($url) {
			echo "<div class=\"navigation\"><a class=\"\" title=\"".APP_NAME."\" href=\"".WWWROOT."/modules/login/main.php\">"._(APP_NAME)."</a> > ";
			$nav = explode("/", $url);
			for($i = 0; $i <= count($nav); $i++) {
				switch($nav[$i]) {
					case "modules": 
						switch($nav[$i+1]) {
							case "boletus": 
								echo "<a class=\"\" title=\""._("Bolets")."\" href=\"".WWWROOT."/modules/boletus/main.php\">"._("Bolets")."</a> > ";
								break; 
							case "positions": 
								echo "<a class=\"\" title=\""._("Localitzacions")."\" href=\"".WWWROOT."/modules/positions/main.php\">"._("Localitzacions")."</a> > ";
								break; 
							case "login": break;
							case "recipes":
								echo "<a class=\"\" title=\""._("Receptes")."\" href=\"".WWWROOT."/modules/recipes/main.php\">"._("Receptes")."</a> > ";
								break;
							case "users":
								if ($this->security->hasPermission('list_users')) { 
									echo "<a class=\"\" title=\""._("Usuaris")."\" href=\"".WWWROOT."/modules/users/main.php\">"._("Usuaris")."</a> > ";
								} else {
									echo _("Usuaris")." > ";
								}
							break;
						}	break ;
					case "confirm.php": echo "<label>"._("Confirmació")."</label>"; break;
					case "create.php": echo "<label>"._("Crear")."</label>"; break;
					case "delete.php": echo "<label>"._("Eliminar")."</label>"; break;
					case "edit.php": echo "<label>"._("Editar")."</label>"; break;
					case "main.php": echo "<label>"._("Inici")."</label>"; break;
					case "register.php": echo "<label>"._("Registrar-se")."</label>"; break;
					case "search.php": echo "<label>"._("Resultats de la cerca")."</label>"; break;
					case "view.php": echo "<label>"._("Visualitzar")."</label>"; break;
					default: if (substr($nav[$i],0,7) == ("report_")) { echo "<label>"._("Entrada de paràmetres")."</label>"; } break;
				}
			}
			echo "</div>";
		}
		
	
		// Funció que retorna la part especificada d'un text, utilizada en els arxius main per mantenir una visibilitat agradable en les taules
		public function shorten($string, $size){
			if (strlen($string) > $size) $s = trim(mb_substr($string, 0, $size, 'UTF-8'))." (...)"; else $s = $string;
			return $s;
		}	
	}

?>