<?
	/**
	 *	Title: Classe Logger, emmagatzema a la base de dades els missatges de log
	 *
	 *	Project: iBoletus
	 *	Author: Victor Llorente Vaquero
	 *	Date: 18/11/2013
	 *	Email: vllorente@uoc.edu
	 **/
		
	class Logger {
		
		private $db = null;
		private $dbConn = null;
		
		public function __construct() {
			$this->db = new Database();
			$this->dbConn = $this->db->getDB();
		}
				
		public function logAction($action) {
			try {
				$st_query_action = $this->dbConn->prepare("select act_id from action_log where act_action = :action limit 1");
				$st_query_action->execute(array('action' => $action));
						
				if ($st_query_action->rowCount() == 1) {
					if ($_SERVER['REMOTE_ADDR']) {
						$headers = apache_request_headers();
						$client_ip = $headers["X-Forwarded-For"];
					}
					
					if (isset($client_ip)) $ip = $client_ip; else $ip = $_SERVER['REMOTE_ADDR'];
					
					$row = $st_query_action->fetch();
					$st_insert = $this->dbConn->prepare("insert into logs (log_date, log_addr_ip, log_usr_id, log_action) values (NOW(), :usr_ip, :usr_id, :action)");
					$data = array( 'usr_ip' => $ip, 'usr_id' => $_SESSION['info_user']['id'], 'action' => $row['act_id'] );
					$st_insert->execute($data);
				}
			} catch (PDOException $e) { $this->db->getError($e); }
		}
		
		public function deleteAllFromDB() {
			try {
				$stmt = $this->dbConn->query("delete from logs where TO_DAYS( NOW( ) ) - TO_DAYS( log_date ) > 30");
			} catch (PDOException $e) { $this->db->getError($e); }
		}
	}
	
?>
