<?
	/**
	 *	Title: Classe Recipes, model per a un grup de receptes.
	 *
	 *	Project: iBoletus
	 *	Author: Víctor Llorente Vaquero
	 *	Date: 21/11/2013
	 *	Email: vllorente@uoc.edu
	 **/

	class Recipes {
	
		private $recipes = array();
		private $db = null;
		private $dbConn = null;
		
		public function __construct() {
			$this->db = new Database();
			$this->dbConn = $this->db->getDB();
		}
				
		public function getTotalRecipesFromDB() {
			try {
				$stmt = $this->dbConn->query("select count(*) from recipes");
				$row = $stmt->fetch();
			} catch (PDOException $e) { $this->db->getError($e); }

			return $row[0];		
		}
		
		public function getRecipesFromDB($order, $page) {
			$start = ($page - 1) * DISPLAY_RECORDS;

			// Ordre per defecte
			if (!isset($order)) $order = "order by rec_name";
			
			$stmt = $this->dbConn->query("select rec_id from recipes $order limit $start, ".DISPLAY_RECORDS);
			foreach ($stmt->fetchAll() as $recipe) {
				$rec = new Recipe($this->db);
				$rec->initWithId($recipe['rec_id']);
				$this->recipes[] = $rec;
			}
		}
		
		public function getAllRecipesFromDB($value = "") {
			$result = array();
			
			$stmt = $this->dbConn->prepare("select rec_id as id, rec_name as description from recipes where rec_name like :value and rec_active = '1' order by rec_name");
			$stmt->execute(array('value' => '%'.$value.'%'));
			
			foreach ($stmt->fetchAll() as $rec) array_push($result, $rec);
			
			return $result;
		}
		
		public function getRecipes() { return $this->recipes; }
		
	}
	
?>