<?
	/**
	 *	Title: Classe Search, model per a la cercar
	 *
	 *	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 04/12/2013
	*	Email: vllorente@uoc.edu
	 **/

	class Search {
	
		private $count;
		private $search = array();
				
		private $db = null;
		private $dbConn = null;
		
		public function __construct() {
			$this->db = new Database();
			$this->dbConn = $this->db->getDB();
		}
		
		// Funció per a fer la cercar segons el mòdul i el text a cercar
		public function getSearchFromDB($module, $valors, $sort, $start) {
			
			// Preparació i ordenació dels camps segons el mòdul seleccionat
			switch ($module) {
				case "boletus":
					// Camps on es farà la cercar 
					$description = array("bol_name", "bol_name_latin");
					// Preparació dels camps a mostrar
					$query_fields = "bol_id, bol_name, bol_name_latin, bol_toxic";
					// En quin ordre mostrar els resultats
					if ($_GET['orderby'] == "name" || $_GET['orderby'] == "name_latin" || $_GET['orderby'] == "toxic") $orderby = $_GET['orderby'];
					// No mostrar per URL el nom dels camps de la base de dades
					switch ($orderby) {
						case "name": $orderby_prev = "bol_name"; break;
						case "name_latin": $orderby_prev = "bol_name_latin"; break;
						case "toxic": $orderby_prev = "bol_toxic"; break;
					}
					break;
				case "recipes":
					// Camps on es farà la cercar 
					$description = array ("rec_name");
					// Preparació dels camps a mostrar
					$query_fields = "rec_id, rec_name, rec_bol_id, rec_usr_id, rec_date";
					// En quin ordre mostrar els resultats
					if ($_GET['orderby'] == "name" || $_GET['orderby'] == "boletus" || $_GET['orderby'] == "user" || $_GET['orderby'] == "date") $orderby = $_GET['orderby'];
					// No mostrar per URL el nom dels camps de la base de dades
					switch ($orderby) {
						case "name": $orderby_prev = "rec_name"; break;
						case "boletus": $orderby_prev = "rec_bol_id"; break;
						case "user": $orderby_prev = "rec_usr_id"; break;
						case "date": $orderby_prev = "rec_date"; break;
					}
					break;
				case "users":
					// Camps on es farà la cercar 
					$description = array("usr_name", "usr_first_last_name", "usr_second_last_name");
					// Preparació dels camps a mostrar
					$query_fields = "usr_id, usr_name, usr_first_last_name, usr_second_last_name";
					// En quin ordre mostrar els resultats
					if ($_GET['orderby'] == "name" || $_GET['orderby'] == "first_last_name" || $_GET['orderby'] == "second_last_name") $orderby = $_GET['orderby'];
					// No mostrar per URL el nom dels camps de la base de dades
					switch ($orderby) {
						case "name": $orderby_prev = "usr_name"; break;
						case "first_last_name": $orderby_prev = "usr_first_last_name"; break;
						case "second_last_name": $orderby_prev = "usr_second_last_name"; break;
					}
					break;
			}
			
			// Modificar el 'order by' de la sentència SQL segons la columna per la que és vol classificar
			if (isset($orderby)) $orderby_fields = $orderby_prev." ".$sort;
			
			// A la variable $valors[] tenim les paraules de tres o més lletres i sense camps buits. Creem la string per a la cerca global.
			if (isset($valors)) { 
				foreach ($valors as $c) {	
					$search_global = $search_global.$c." ";
				}
			}
			
			$search_global = trim($search_global);
			
			// Cercar globalment
			if (isset($valors)) {
				
				$relevance = "(";
				for ($x = 0; $x < count($valors); $x++) {
					$relevance .= "(CASE WHEN ";
					for ( $y = 0; $y < count($description); $y++) {
						if ($y != 0) $relevance.= " or ";
						$relevance .= $description[$y]. " like '%".$valors[$x]."%'";
					}
					$relevance .= " THEN 1 ELSE 0 END)";
					if ($x != count($valors)-1) $relevance .= " + ";
				}
				$relevance .= ") AS relevance";
				
				$query_count = " SELECT count(*) FROM ".$module." WHERE (";
				$query_relevance = " SELECT ".$query_fields.", ".$relevance." FROM ".$module." WHERE (";
				
				for ($x = 0; $x < count($valors); $x++) {
					$query_count .= "(";
					$query_relevance .= "(";
					for ( $y = 0; $y < count($description); $y++) {
						if ($y != 0) { $query_count .= " or "; $query_relevance .= " or "; }
						$query_count .= $description[$y]." like '%".$valors[$x]."%'";
						$query_relevance .= $description[$y]." like '%".$valors[$x]."%'";
					}
					$query_count .= ")";
					$query_relevance .= ")";
					if ($x != count($valors)-1) { $query_count .= " or "; $query_relevance .= " or "; }
				}
				
				// Indicar l'order de la sentència SQL, si no s'ha indicat la classificació per alguna
				// de les columnes, s'ha d'ordenar per rellevància, altrament per la columna que s'ha
				// especificat en la interfície
				if (!isset($orderby)) $orderby_relevance = "relevance desc"; else $orderby_relevance = $orderby_fields;
				
				$query_count .= ") ".$query_cond;
				$query_relevance .= ") ".$query_cond." order by ".$orderby_relevance." limit " .$start. ", " .DISPLAY_RECORDS;
				
				// Query count
				try {
					$stmt = $this->dbConn->query($query_count);
					$row = $stmt->fetch();
				} catch (PDOException $e) { $this->db->getError($e); }
				
				$this->count = $row[0];
				
				// Query relevance
				$stmt = $this->dbConn->query($query_relevance);
				foreach ($stmt->fetchAll() as $search){
					switch ($module) {
						case "boletus":
							$boletu = new Boletu($this->db);
							$boletu->initWithId($search['bol_id']);
							$this->search[] = $boletu;
							break;
						case "recipes":
							$recipe = new Recipe($this->db);
							$recipe->initWithId($search['rec_id']);
							$this->search[] = $recipe;
							break;
						case "users": 
							$user = new User($this->db);
							$user->initWithId($search['usr_id']);
							$this->search[] = $user;
							break;
					}
				}
			}
		}
		
		public function getCount() { return $this->count; }
		
		public function getSearch() { return $this->search; }
	}
	
?>