<?
	/**
	 *	Title: Classe Security, s'encarrega de verificar aspectes de seguretat amb dades i permisos.
	 *
	 *	Project: iBoletus
	 *	Author: Victor Llorente Vaquero
	 *	Date: 18/11/2013
	 *	Email: vllorente@uoc.edu
	 **/
		
	class Security {
		private $db = null;
		private $dbConn = null;
		
		public function __construct() {
			$this->db = new Database();
			$this->dbConn = $this->db->getDB();
		}
				
		public function isLogged() { return isset($_SESSION['info_user']['user']); }
		
		public function hasPermission($permission) {
			$grant = false;

			try {
				$stmt = $this->dbConn->prepare("select rpe_value from permissions inner join roles_permissions on per_id = rpe_permission_id inner join roles on rol_role_id = rpe_role_id where per_permission = :permission and rol_role_id = :role limit 1");
				$stmt->execute(array('role' => $_SESSION['info_user']['role'], 'permission' => $permission));
				$row = $stmt->fetch();
			} catch (PDOException $e) { $this->db->getError($e); }
			
			if ($row['rpe_value'] == "1") $grant = true;
			
			return $grant;
		}
	
		public function isIdValid($id, $table, $field) {
			$valid = false;

			try {
				$stmt = $this->dbConn->prepare("select ".$field." from ".$table." where ".$field." = :id limit 1");
				$stmt->execute(array('id' => $id));
				if ($stmt->rowCount() == 1) $valid = true;
			} catch (PDOException $e) { $this->db->getError($e); }
			
			return $valid;
		}
	}
	
?>