<?

class Sorter {
	
	private $page;
	private $numPages;

	private $orderBy;
	private $previousOrderBy;

	private $sort;
	private $sortFields;
	
	private $modQueryOrder;
	private $modURLOrder;

	public function __construct(array $parameters, $records, array $orderFieldsArray = array()) {

		(is_numeric($parameters['page']) && $parameters['page'] > 0) ? $this->page = $parameters['page'] : $this->page = 1;
		
		$this->sortFields = $orderFieldsArray;

		foreach ($this->sortFields as $of) {
			if (array_key_exists(strtolower($parameters['orderby']), $of)) {
				$this->orderBy = strtolower($parameters['orderby']);
				$this->previousOrderBy = strtolower($of[$this->orderBy]);
			}
		}
		
		if (strtolower($parameters['sort']) == "asc" || strtolower($parameters['sort']) == "desc") $this->sort = strtolower($parameters['sort']);
		
		if (isset($this->orderBy)) $this->modQueryOrder = "order by ".$this->previousOrderBy." ". $this->sort;
		
		$this->sort == "asc" ? $reverse = "desc" : $reverse = "asc";
		$this->modURLOrder = "orderby=".$this->orderBy."&sort=".$reverse;
		
		$records > 0 ? $this->numPages = intval($records / DISPLAY_RECORDS) : $this->numPages = 1;
		if ($records % DISPLAY_RECORDS) $this->numPages++;
	}
		
	public function getSortLabel($value){
		$data = $this->sortFields[$value];
		if (is_array($data) && !empty($data)) {
			if ($this->previousOrderBy != current($data)) $modURLOrder = "orderby=".key($data)."&sort=asc"; else $modURLOrder = $this->modURLOrder;
			$label = "<a title=\""._($value)."\" href=\"".WWWROOT.$_SERVER['PHP_SELF']."?page=".$this->page."&".$modURLOrder."\">"._($value)."</a>";
		} else {
			$label = _($value);
		}
		
		return $label;
	}
	
	public function getPaginationDiv($module = ""){
		
		$pagination = "<div class=\"pagination\"><center>";
		
		if ($this->orderBy != "") $extra .= "&orderby=".$this->orderBy;
		if ($this->sort != "") $extra .= "&sort=".$this->sort;
		if ($module != "") $mod_module = "mod=".$module;
		
		$prev = $this->page - 1;
		$next = $this->page + 1;
		
		$adjacent = 9;
		
		$from = $this->page - $adjacent;
		$to = $this->page + $adjacent;

		if ($from < 1) $from = 1;
		if ($to >= $this->numPages) $to = $this->numPages;
		
		if ($this->page > 1) {
			$pagination .= "<a href=\"".$_SERVER['PHP_SELF']."?".$mod_module."&page=1".$extra."\"><img class=\"img_button\" title=\""._("Primer")."\" src=".IMG_FIRST."></a> ";
			$pagination .= "<a href=\"".$_SERVER['PHP_SELF']."?".$mod_module."&page=".$prev.$extra."\"><img class=\"img_button\" title=\""._("Anterior")."\" src=".IMG_PREV."></a> ";
		}
	
		for ($i = $from; $i <= $to; $i++) {
			if ($i == $this->page)
				$pagination .= "<b>".$i."</b>&nbsp;";
			else
				$pagination .= "<a href=\"".$_SERVER['PHP_SELF']."?".$mod_module."&page=".$i.$extra."\">".$i."</a> ";
		}
		
		if ($this->page < $this->numPages) {
			if ($this->page < $this->numPages) $pagination .= "<a href=\"".$_SERVER['PHP_SELF']."?".$mod_module."&page=".$next.$extra."\"><img class=\"img_button\" title=\""._("Següent")."\" src=".IMG_NEXT."></a> ";
			if ($this->page != $this->numPages) $pagination .= "<a href=\"".$_SERVER['PHP_SELF']."?".$mod_module."&page=".$this->numPages.$extra."\"><img class=\"img_button\" title=\""._("Últim")."\" src=".IMG_LAST."></a>";
		}

		
		$pagination .= "</center></div>";
		
		return $pagination;
	}
	
	public function getModQueryOrder(){ return $this->modQueryOrder; }
	public function getPage() { return $this->page; }
	public function getOrderBy() { return $this->orderBy; }
	public function getSort() { return $this->sort; }
	public function getNumPages() { return $this->numPages; }
	public function isPageInvalid() { return ($this->page > $this->numPages); }
}

?>