<?
	/**
	 *	Title: Classe Users, model per a un grup d'usuaris.
	 *
	 *	Project: iBoletus
	 *	Author: Victor Llorente Vaquero
	 *	Date: 18/11/2013
	 *	Email: vllorente@uoc.edu
	 **/

	
	class Users {
	
		private $users = array();		
		private $db = null;
		private $dbConn = null;
		
		public function __construct() {
			$this->db = new Database();
			$this->dbConn = $this->db->getDB();
		}
				
		public function getTotalUsersFromDB() {
			try {
				$stmt = $this->dbConn->query("select count(*) from users");
				$row = $stmt->fetch();
			} catch (PDOException $e) { $this->db->getError($e); }

			return $row[0];		
		}
		
		public function getUsersFromDB($order, $page) {
			$start = ($page - 1) * DISPLAY_RECORDS;

			// Ordre per defecte
			if (!isset($order)) $order = "order by usr_first_last_name, usr_second_last_name, usr_name";
			
			$stmt = $this->dbConn->query("select usr_id from users $order limit $start, ".DISPLAY_RECORDS);
			foreach ($stmt->fetchAll() as $user) {
				$usr = new User($this->db);
				$usr->initWithId($user['usr_id']);
				$this->users[] = $usr;
			}
		}
		
		public function getUsers() {
			return $this->users;
		}
	}
	
?>