<?
	
	/**
	 *	Title: Arxiu amb les constants de l'aplicació
	 *
	 *	Project: iBoletus
	 *	Author: Victor Llorente Vaquero
	 *	Date: 18/11/2013
	 *	Email: vllorente@uoc.edu
	 **/
	
	// Missatges d'error
	define('ERROR_REGEXP', _("Les dades entrades no són vàlides."));
	define('ERROR_EMPTY', _("Aquest camp és necessari."));
	define('ERROR_LOGIN', _("Nom d'usuari o contrasenya incorrectes."));
	define('ERROR_USER_REPEATED', _("Atenció: Existeix un usuari amb aquest nom d'usuari, no poden existir noms d'usuari repetits."));
	define('INFO_NO_DATA', _("No hi ha dades a visualitzar."));
	define('INFO_NO_DATA_SPECIFY', _("No especificat"));
	define('INFO_CHOOSE_OPTION', _(" - Escolliu una opció - "));
	define('INFO_CHOOSE_OPTION_MODULE', _(" - Selecciona mòdul - "));
	define('INFO_MESSAGE_DELETE', _("Atenció: Aquesta acció no es pot desfer."));
	define('INFO_MESSAGE_INVALID_DATA', _("Atenció: Falta omplir camps necessaris o les dades que has introduït no són correctes, si us plau revisa el formulari."));
	
	// Codis d'error
	define('ERROR_DB', '1');
	define('ERROR_PERMISSION', '2');
	define('ERROR_UPLOAD', '3');
	define('ERROR_CREATE_FOLDER', '4');
	define('ERROR_REPORT', '5');
	define('ERROR_NOT_FOUND', '6');
	define('ERROR_ACCESS_FORBIDDEN', '7');
	define('ERROR_TAMPERED_DATA', '8');
	define('ERROR_FILE_NOT_FOUND', '9');
	define('ERROR_UPLOAD_IMAGE', '10');
	
	//Formularis
	define('INPUT_EMPTY', 1);
	define('INPUT_INVALID', 2);
	define('INPUT_REPEATED', 3);
	
	define('VIEW_MODE', 0);
	define('EDIT_MODE', 1);
	
	define('FIELD_TEXT', 0);
	define('FIELD_YES_NO', 1);
	define('FIELD_SELECT', 2);
	define('FIELD_DATE', 3);
	define('FIELD_TEXTAREA', 4);
	define('FIELD_YEAR', 5);
	define('FIELD_PASSWORD', 6);
	define('FIELD_CHECK', 7);
	define('FIELD_DECIMAL', 8);
	define('FIELD_OPEN_CLOSE', 9);
	define('FIELD_FILE', 10);
	define('FIELD_PHOTO', 11);
	define('FIELD_LINK', 12);
	define('FIELD_SELECT_SEARCH', 13);
	define('FIELD_EMAIL', 14);
	
	// Expressions regulars
	define('RE_ANY', 0);
	define('RE_ALFA', 1);
	define('RE_ALFANUM', 2);
	define('RE_NUM', 3);
	define('RE_NUM_DEC', 4);
	define('RE_NUM_DEC_COMA', 5);
	define('RE_DATE_FW', 6);
	define('RE_DATE_BW', 7);
	define('RE_USERNAME', 8);
	define('RE_PHONE', 9);
	define('RE_ID', 10);
	define('RE_ID_TOKEN', 11);
	define('RE_PASSWORD', 12);
	define('RE_BOOL', 13);
	define('RE_EMAIL', 14);
	define('RE_DATE', 15);
	
	define('TEST_DEFAULT', 0);
	define('TEST_SELECT', 1);
	define('TEST_PASSWORD', 2);
	define('TEST_DATE', 3);
	define('TEST_CHECK', 4);
	define('TEST_COMPARE_DATE', 5);
	define('TEST_FILE', 6);
	
	// Paràmetres de taules
	define('TABLE_SYSTEM', 1);
	define('TABLE_SUPPORT', 2);
	define('TABLE_ROLES', 3);
	define('TABLE_USERS', 4);
	define('TABLE_BOLETUS', 5);
	define('TABLE_RECIPES', 6);
	
	// Paràmetres de l'aplicació
	define('DISPLAY_RECORDS', '12');
	define('MAX_INPUT', '100');
	define('MIN_AJAX_INPUT', '3');
	define('MIN_PASS_LENGTH', '4');
	define('YEARS_AHEAD', '10');
	define('DEFAULT_NUMBER_DECIMALS', '2');
	define('MAX_FILE_SIZE', '204800');
	define('PHOTO_WIDTH', '200');
	define('PHOTO_HEIGHT', '200');
	
	// Paràmetres de confirmació
	define('CONFIRM_DELETE', '0');
	define('CONFIRM', '1');
	
	// Imatges
	define('IMG_VIEW', WWWROOT.'/images/icons/16x16/actions/system-search.png');
	define('IMG_SEARCH', WWWROOT.'/images/icons/16x16/actions/system-search.png');
	define('IMG_EDIT', WWWROOT.'/images/icons/16x16/actions/document-properties.png');
	define('IMG_DELETE', WWWROOT.'/images/icons/16x16/places/user-trash.png');
	define('IMG_FIRST', WWWROOT.'/images/icons/16x16/actions/go-first.png');
	define('IMG_LAST', WWWROOT.'/images/icons/16x16/actions/go-last.png');
	define('IMG_PREV', WWWROOT.'/images/icons/16x16/actions/go-previous.png');
	define('IMG_NEXT', WWWROOT.'/images/icons/16x16/actions/go-next.png');
	define('IMG_ON', WWWROOT.'/images/icons/16x16/actions/green-badge.png');
	define('IMG_OFF', WWWROOT.'/images/icons/16x16/actions/media-record.png');
	define('IMG_BUTTON_EXIT', WWWROOT.'/images/icons/32x32/actions/system-log-out.png');
	define('IMG_BUTTON_CONFIG', WWWROOT.'/images/icons/32x32/actions/config-properties.png');
	define('IMG_BUTTON_CREATE', WWWROOT.'/images/icons/32x32/actions/document-new.png');
	define('IMG_BUTTON_MAP', WWWROOT.'/images/icons/32x32/actions/map_view.png');
	define('IMG_BUTTON_SAVE_AS', WWWROOT.'/images/icons/32x32/actions/document-save-as.png');
	define('IMG_BUTTON_EDIT', WWWROOT.'/images/icons/32x32/actions/document-properties.png');
	define('IMG_BUTTON_DELETE', WWWROOT.'/images/icons/32x32/places/user-trash.png');
	define('IMG_BUTTON_SEARCH', WWWROOT.'/images/icons/32x32/actions/system-search.png');
	
?>