<?
	/**
	* Title : Modificar les mides d'una imatge
	*
	* Content :
	*
	* Arxiu per a tractar les imatges que és mostren, la seva funció és reduïr qualsevol de les imatges que és mostrin de la gestió
	* com per exemple la foto de l'usuari a unes mides predefinides, encara que l'arxiu sigui d'unes dimensions majors.
	*
	* Project : iBoletus
	* Author : Victor Llorente Vaquero
	* Date : 25/11/2013
	* Email : vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../config.php");
	require_once(DIRLIB."/functions.php");
	
	$r = new Redirector();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	
	// Comprovar la sessió, les preferències i els permisos
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	//if (!$sm->hasPermission('view_photo')) $err->showError(ERROR_PERMISSION);
	
	$image = DIRDATA."/".$_GET['mod']."/".$_GET['img'];
	
	$width = $_GET['w'];
	$height = $_GET['h'];

	// NOTA : getimagesize : generar un array que conté en cadascun dels seus
	// índexs les següents dades de la imatge :
	//		[0] : ample		[1]	: alçada		[2] : tipus d'imatge (1:gif, 2:jpg, 3:png)
	$params = getimagesize($image);
	
	// NOTA : imagecreatefromgif, imagecreatefromjpeg i imagecreatefrompng retornen 
	// el identificador de la imatge que representar la imatge obtinguda des de el
	// nom de l'arxiu passat com a paràmetre.
	if ($params[2] == 1) $img = @imagecreatefromgif($image);	
	if ($params[2] == 2) $img = @imagecreatefromjpeg($image);
	if ($params[2] == 3) $img = @imagecreatefrompng($image);

	// NOTA : imagecreatetruecolor : crear una imatge nova en color real (true color) i
	// retornar un identificador d'imatge representat una imatge en blanc de mida alçada
	// per amplada.
	$thumb = imagecreatetruecolor($width, $height);

	// NOTA : imagecopyresampled : copia una porció rectangular d'una imatge sobre una altra,
	// mitigant els valors dels píxels mitjançant interpolació de manera que al reduïr la mida 
	// de la imatge, encara manté una bona claretat. Dins del parèntesis s'han d'incloure :
	//	- $thumb : identificador de la imatge destí, aixó vol dir, el paper fotografic que hem creat amb 'imagecreatetruecolor'
	//	- $img : identificador de la imatge origen (negatiu) obtinguda amb 'imagecreatefromjpeg' o 'imagecreatefromgif' o 'imagecreatefrompng'
	//	- Xd e Yd : coordenades d'un punt situat al canto superior esquerra del paper a partir del que volem que es mostri la imatge, si volem
	//		una imatge sense marges posarem 0,0, i, si volem deixar marges en blanc, s'haurà de posar els amples d'aquests marges (esquerra i superior)
	//		respectivament.
	//	- Xf e Yf : ens serviran per a reencuadrar la foto original retallant per l'esquerra i per d'alt, respectivament, els amples que s'indiquin
	//		aquí amb píxels.
	//	- $width i $height, son l'ample i l'alt màxim que definim per a la imatge que volem mostrar.
	//	- Fx e Fy : indiquen el ample i l'alt de la porció de l'original que tractem de reproduïr.
	imagecopyresampled($thumb, $img, 0, 0, 0, 0, $width, $height, $params[0], $params[1]);

	// Amb header("Content-type: image/gif") e imagegif($thumb) (o jpeg o png, segons el cas) mostrem la imatge
	if ($params[2] == 1) {
		header("Content-type: image/gif");
		imagegif($thumb);
	}
	if ($params[2] == 2) { 
		header("Content-type: image/jpeg");
		imagejpeg($thumb);
	}
	if ($params[2] == 3) {
		header("Content-type: image/png");
		imagepng($thumb);
	}

	// Amb imagedestroy($thumb) alliberem la memòria associada a la imatge
	imagedestroy($thumb);

?>
