<?
	/**
	*	Title : Creació d'una string en format XML, amb les dades recuperades d'una consulta SQL
	*
	*	Content :
	*
	*	El valor que recuperem per URL provinent de la funció 'showResultAjax(str, module)', que 
	*	es troba a l'arxiu '/scripts/js/ajax.js' i que el valor entrat sigui superior
	*	a 2 caràcters, realitzar la consulta SQL cap a la base de dades, a la taula 
	*	corresponent per obtenir una llista de coincidències sobre el camps a cercar.
	*	A continuació, es crea un objecte, on s'aniran enregistrant els valors que trobem
	*	segons els paràmetres de la cercar, aquest objecte es trobarà en format XML.
	*	I finalment, crear una 'string' amb l'objecte obtingut.
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 21/11/2013
	*	Email: vllorente@uoc.edu
	**/

	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$log = new Logger();
	$sm = new Security();
	
	// Comprovar la sessió, les preferències i els permisos
	if (!$sm->isLogged()) { $log->logAction('session_error'); exit(); }
	
	// Recuperem el paràmetre o cadena de la URL a cercar
	$value = trim($_GET['value']);
	$module = trim($_GET['module']);

	if (strlen($value) < MIN_AJAX_INPUT) exit();
	
	// Controlar els valors passats per paràmetre	
	$fv = new Validator($_GET);
		
	$fv->setRestriction('value', RE_ALFANUM, true);
	$fv->setRestriction('module', RE_ALFA, true);
	$fv->validate();
		
	if (!$fv->isFormValid()) exit();
	
	// Segons el mòdul
	switch($module) {
		case "boletus":
			$boletus = new Boletus();
			$content = $boletus->getAllBoletusFromDB($value);
			break;
		default: exit; break;
	}
	
	// Creació d'un objecte amb format XML, on es recullen tots els resultats de la consulta SQL
	$xmlDoc = new DOMDocument('1.0', 'UTF-8');

	$elements = $xmlDoc->appendChild($xmlDoc->createElement('elements'));
	
	foreach ($content as $c) {
		
		$element = $elements->appendChild($xmlDoc->createElement('element'));

		$id = $element->appendChild($xmlDoc->createElement('id'));
		$id->appendChild($xmlDoc->createTextNode(ht($c["id"])));
	
		$description = $element->appendChild($xmlDoc->createElement('description'));
		$description->appendChild($xmlDoc->createTextNode(ht($c["description"])));
	}

	$xmlDoc->formatOutput = true;

	// A partir de l'objecte en format XML, transformar l'objecte a una string
	echo $xmlDoc->saveXML();
	
?>