<?
	/**
	*	Title : Eliminar un bolet
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 20/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();
	
	// Comprovar la sessió i els paràmetres d'entrada
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	$sm->isIdValid($_GET['id'], 'boletus', 'bol_id') ? $bol_id = $_GET['id'] : $r->returnTo();
	
	$boletu = new Boletu($db);
	$boletu->initWithId($bol_id);
	
	// Comprovar els permisos
	if (!$sm->hasPermission('remove_boletus') && $boletu->getBoletuUserId() != $_SESSION['info_user']['id']) $err->showError(ERROR_PERMISSION);
	
	// Accions amb botons
	if ($_POST['action']) {
	
		switch($_POST['selected_action']) {
			
			// Eliminar bolet
			case _("Eliminar"):
								
				$boletu->deleteFromDB();
				unset($boletu);
				
				$log->logAction('delete_boletu');
				
				// Eliminar la fotografia del bolet, sempre i quan hi haguí fotografia a la carpeta '/var/iboletusdata/boletus/'
				remove_photo("boletus", $bol_id);
		
				// Redirigir cap a la pàgina anterior si s'ha elimant correctament		
				$r->returnTo();
				break;
			
			// Redirigir a la pàgina 'view.php' del mòdul 'boletus'
			case _("Sortir"):
				$r->redirect('boletus', 'view.php', array('id' => $bol_id));
				break;
		}
	}
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Eliminar bolet"));
	
	if (!$detect->isMobile() && !$detect->isTablet()) { ?>
		<div class="actions">
			<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
			<div class="clear"></div>
		</div>
<?	}

	$c->getDivConfirm(INFO_MESSAGE_DELETE, sprintf("Si us plau, confirma que desitges eliminar definitivament el bolet:<br><br><b>%s</b><br>%s<br>", ht($boletu->getBoletuName()), ht($boletu->getBoletuNameLatin())), "Eliminar", "Sortir", CONFIRM_DELETE);
	
	$c->getFooter();
?>
