<?
	/**
	*	Title : Edició d'un bolet
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 20/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();

	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();
	
	// Comprovar la sessió i els paràmetres d'entrada
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	$sm->isIdValid($_GET['id'], 'boletus', 'bol_id') ? $bol_id = $_GET['id'] : $r->returnTo();
	
	$boletu = new Boletu($db);
	$boletu->initWithId($bol_id);
	
	// Comprovar els permisos
	if (!$sm->hasPermission('edit_boletus') && $boletu->getBoletuUserId() != $_SESSION['info_user']['id']) $err->showError(ERROR_PERMISSION);

	$fv = new Validator($_POST);
		
	// Accions amb botons
	if ($_POST['action']) { 
		switch($_POST['selected_action']) {
			case _("Desar"):
				
				$boletu->setBoletuName($fv->getFormEntry('name', 100));
				$boletu->setBoletuNameLatin($fv->getFormEntry('name_latin', 100));
				$boletu->setBoletuToxic($fv->getFormEntry('toxic'));
				$boletu->setBoletuDescription($fv->getFormEntry('description', 4096));
				$boletu->setBoletuHabitat($fv->getFormEntry('habitat', 4096));
				$boletu->setBoletuObservation($fv->getFormEntry('observation', 4096));
				
				$fv->setRestriction('name', RE_ALFANUM, true);
				$fv->setRestriction('name_latin', RE_ALFANUM, false);
				$fv->setRestriction('toxic', RE_BOOL, true);
				$fv->setRestriction('description', RE_ALFANUM, true);
				$fv->setRestriction('habitat', RE_ALFANUM, false);
				$fv->setRestriction('observation', RE_ALFANUM, false);

				$fv->validate();

				// En aquest punt es consideren les dades correctes i ja es poden desar a la base de dades.
				if ($fv->isFormValid()) {
					$boletu->updateInDB();
					$log->logAction('edit_boletu');
					if (!empty($_FILES['create_photo']['name'])) { add_photo($_FILES['create_photo']['tmp_name'], 'boletus', $bol_id, $_FILES['create_photo']['name']); }
					$r->redirect('boletus', 'view.php', array('id' => $bol_id));
				}
				break;
				
			case _("Sortir"):
				$r->redirect('boletus', 'view.php', array('id' => $bol_id));
				break;
		}
	}
	
	// Preparació per la destrucció de les cookies de 'edit' i 'view'
	$cookie_view = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_edit = preg_replace("/view/", "edit", $cookie_view);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Editar bolet"));
	
?>
	
	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
		}
	</script>
	
	<form class="global" name="form" accept-charset="UTF-8" method="post" enctype="multipart/form-data">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
				<div class="options">
					<input title="<?=_('Desar')?>" class="button" type="submit" name="selected_action" value="<?=_('Desar')?>">
					<input title="<?=_('Sortir')?>" class="button" type="submit" name="selected_action" onClick="deleteCookie('<?=$cookie_view?>', '/'); deleteCookie('<?=$cookie_edit?>', '/');" value="<?=_('Sortir')?>">
				</div>
				<div class="clear"></div>
			</div>
		<? } ?>
		<? if (!$fv->isFormValid()) echo $c->getMessage(INFO_MESSAGE_INVALID_DATA, 1); ?>
		
		<div class="tabbed_box">
			<div class="content_section">
				<? $c->getDiv("Nom:", $boletu->getBoletuName(), "name", EDIT_MODE, FIELD_TEXT, $fv->getError('name')); ?>
				<? $c->getDiv("Nom en llatí:", $boletu->getBoletuNameLatin(), "name_latin", EDIT_MODE, FIELD_TEXT, $fv->getError('name_latin')); ?>
				<? $c->getDiv("és comestible:", $boletu->getBoletuToxic(), "toxic", EDIT_MODE, FIELD_YES_NO, $fv->getError('toxic')); ?>
				<? $c->getDiv("Descripció:", $boletu->getBoletuDescription(), "description", EDIT_MODE, FIELD_TEXTAREA, $fv->getError('description')); ?>
				<? $c->getDiv("Hàbitat:", $boletu->getBoletuHabitat(), "habitat", EDIT_MODE, FIELD_TEXTAREA, $fv->getError('habitat')); ?>
				<? $c->getDiv("Observacions:", $boletu->getBoletuObservation(), "observation", EDIT_MODE, FIELD_TEXTAREA, $fv->getError('observation')); ?>
				<? $c->getDiv("Fotografia:", $photo, "photo", EDIT_MODE, FIELD_PHOTO, $fv->getError('photo'), "", "create_photo"); ?>
				<? if ($detect->isMobile() || $detect->isTablet()) { ?>
					<div class="options">
						<input title="<?=_('Desar')?>" class="button" type="submit" name="selected_action" value="<?=_('Desar')?>">
						<input title="<?=_('Sortir')?>" class="button" type="submit" name="selected_action" onClick="deleteCookie('<?=$cookie_view?>', '/'); deleteCookie('<?=$cookie_edit?>', '/');" value="<?=_('Sortir')?>">
					</div>
				<? } ?>
				<div class="clear"></div>
			</div>
		</div>
		<input type="hidden" name="action" value="1"/>
	</form>
	
<? $c->getFooter(); ?>
