<?
	/**
	*	Title: Llistat de bolets
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 10/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$r = new Redirector();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();
	
	// Comprovar la sessió, les preferències i els permisos
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	
	$c = new Content();
	$boletus = new Boletus();
	
	// Si s'ha demanat de crear un nou bolet no cal fer res més
	if ($_POST['action'] && $_POST['action_new']) $r->redirect('boletus', 'create.php');

	// Preparem la taula d'ordenació
	$sortParameters = array ('Bolet' => array ('name' => 'bol_name'), 'Nom en llatí' => array ('latin' => 'bol_name_latin'), 'Comestible' => array ('toxic' => 'bol_toxic'));

	// Obtenim el nombre total de registres a mostrar
	$numRecords = $boletus->getTotalBoletusFromDB();
	
	$sorter = new Sorter($_GET, $numRecords, $sortParameters);
	if ($sorter->isPageInvalid()) { $r->redirect('boletus', 'main.php'); }
	
	// Obtenim els registres a mostrar per pàgina i ordenació
	$boletus->getBoletusFromDB($sorter->getModQueryOrder(), $sorter->getPage());

	// Preparem la pàgina de retorn en cas d'errors
	$r->setReturnTo('boletus', 'main.php', $sorter->getPage(), $sorter->getOrderBy(), $sorter->getSort());
	
	// Etiqueta amb les opcions del mòdul
	if (!$detect->isMobile() && !$detect->isTablet()) { 
		$div_options = "<div class=\"options\"><input title=\""._("Nou bolet...")."\" class=\"button\" type=\"submit\" name=\"action_new\" value=\""._("Nou bolet...")."\"></div>";
	} else {
		$div_options = "<div class=\"options\"><a href=\"".WWWROOT."/modules/boletus/create.php\"><img style=\"float:right; margin-right: 5px\" title=\""._("Nou bolet...")."\" src=\"".IMG_BUTTON_CREATE."\"></a></div>";
	}
		
	// Preparació de les cookies a eliminar
	$cookie = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_view = preg_replace("/main/", "view", $cookie);
	$cookie_edit = preg_replace("/main/", "edit", $cookie);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Llistat de bolets"));
	
?>
	
	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
		}
	</script>
	
	<form name="form" accept-charset="UTF-8" method="post">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); 
				echo $div_options; ?>
				<div class="clear"></div>
			</div>
		<? } ?>
		<? $count = (($sorter->getPage() - 1) * DISPLAY_RECORDS) + 1; ?> 
		<? if ($numRecords > 0) { ?>
			<div class="table_section">
				<div class="section_entry"><label class="label_header"><?=_("Bolets") ." (".$numRecords.")";?></label></div>
				<? if ($detect->isMobile() || $detect->isTablet()) { echo $div_options; } ?>
				<? if ($numRecords > DISPLAY_RECORDS) echo $sorter->getPaginationDiv(); ?>
				<table width="100%">
					<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
						<tr>
							<td class="table_img_cell"></td>
							<? if ($sm->hasPermission('edit_boletus')) { ?><td class="table_img_cell""></td><? } ?>
							<? if ($sm->hasPermission('remove_boletus')) { ?><td class="table_img_cell"></td><? } ?>
							<td></td>
							<td class="table_header"><?=_('Bolet');?></td>
							<td class="table_header"><?=_('Nom en llatí');?></td>
							<td nowrap class="table_img_cell table_header"><?=_('Comestible');?></td>
						</tr>
						
						<? foreach ($boletus->getBoletus() as $boletu) { ?>
							<tr>
								<td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/boletus/view.php?id=<?=$boletu->getBoletuId();?>"><img title="<?=_('Visualitzar')?>" src="<?=IMG_VIEW?>"/></a></td>
								<? if ($sm->hasPermission('edit_boletus')) { ?><td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/boletus/edit.php?id=<?=$boletu->getBoletuId()?>"><img title="<?=_('Editar')?>" src="<?=IMG_EDIT?>"/></a></td><? } ?>
							 	<? if ($sm->hasPermission('remove_boletus')) { ?><td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/boletus/delete.php?id=<?=$boletu->getBoletuId()?>"><img title="<?=_('Eliminar')?>" src="<?=IMG_DELETE?>"></a></td><? } ?>
								<td class="table_count_cell row<?=$count&1?>"><?=$count?></td>
								<td class="row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/boletus/view.php?id=<?=$boletu->getBoletuId()?>"><?=ht($boletu->getBoletuName());?></a></td>
								<td class="row<?=$count&1?>"><?=ht($boletu->getBoletuNameLatin());?></td>
								<td nowrap class="table_img_cell row<?=$count&1?>"><? if ($boletu->getBoletuToxic()) { ?><img title="<?=_('Comestible')?>" src="<?=IMG_ON?>"/><? } else { ?><img title="<?=_('Tòxic')?>" src="<?=IMG_OFF?>"/><? } ?></td>
							</tr>
						<?  $count++; 
						   }
					} else {
						foreach ($boletus->getBoletus() as $boletu) { ?>
							<tr>
								<td><a href="<?=WWWROOT?>/modules/boletus/view.php?id=<?=$boletu->getBoletuId();?>"><img src="<?=view_photo('boletus', $boletu->getBoletuId(), 100, 100);?>"></a></td>
								<td>
									<label class="name_title_table"><?=ht($boletu->getBoletuName());?></label>
									<br>
									<label class="name_subtitle_table"><?=ht($boletu->getBoletuNameLatin());?></label>
								</td>
							</tr>
						<?  $count++; 
						}
					} ?>
				</table>
				<? if ($numRecords > DISPLAY_RECORDS) echo $sorter->getPaginationDiv(); ?>
			</div>
		<? } else { ?>
			<div class="no_results"><?=INFO_NO_DATA?></div>
			<? if ($detect->isMobile() || $detect->isTablet()) { echo $div_options; } ?> 
		<? } ?>
		<input type="hidden" name="action" value="1"/>
	</form>

<? $c->getFooter(); ?>
