<?
	/**
	*	Title : Visualització d'un bolet
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 20/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();
	
	// Comprovar la sessió, les preferències i els permisos
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	
	// Comprovar els paràmetres d'entrada
	$sm->isIdValid($_GET['id'], 'boletus', 'bol_id') ? $bol_id = $_GET['id'] : $r->returnTo();
	
	// Accions amb botons
	if ($_POST['action']) { 
		switch($_POST['selected_action']) {
			case _("Editar..."): $r->redirect('boletus', 'edit.php', array (id => $bol_id)); break;
			case _("Eliminar..."): $r->redirect('boletus', 'delete.php', array (id => $bol_id)); break;
			case _("Sortir"): $r->returnTo(); break;
		}
	}
	
	$boletu = new Boletu($db);
	$boletu->initWithId($bol_id);
	
	$user = new User($db);
	$user->initWithId($boletu->getBoletuUserId());
	
	// Preparació per la destrucció de les cookies de 'edit' i 'view'
	$cookie_view = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_edit = preg_replace("/view/", "edit", $cookie_view);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Visualitzar bolet"));

?>
	
	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
		}
	</script>
	
	<form class="global" name="form" accept-charset="UTF-8" method="post">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
				<div class="options">
					<? if ($sm->hasPermission('edit_boletus') || $boletu->getBoletuUserId() == $_SESSION['info_user']['id']) { ?><input title="<?=_('Editar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Editar...')?>"><? } ?>
					<? if ($sm->hasPermission('remove_boletus') || $boletu->getBoletuUserId() == $_SESSION['info_user']['id']) { ?><input title="<?=_('Eliminar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Eliminar...')?>"><? } ?>
					<input title="<?=_('Sortir');?>" class="button" type="submit" name="selected_action" value="<?=_('Sortir')?>">
				</div>
				<div class="clear"></div>
			</div>
		<? } ?>
	
		<div class="tabbed_box">
			<div class="content_section">
				<? $c->getSectionHeader($boletu->getBoletuName()); ?>
				<? $c->getDiv("", view_photo('boletus', $bol_id, PHOTO_WIDTH, PHOTO_HEIGHT), "", VIEW_MODE, FIELD_PHOTO, $boletu->getBoletuName()); ?>
				<? if ($user->isNotEmpty()) $c->getDiv("Boletaire:", $boletu->getBoletuUserFullName()); ?>
				<? $c->getDiv("Nom en llatí:", $boletu->getBoletuNameLatin()); ?>
				<? $c->getDiv("És comestible:", $boletu->getBoletuToxic(), "", VIEW_MODE, FIELD_YES_NO); ?>
				<? $c->getDiv("Descripció:", $boletu->getBoletuDescription()); ?>
				<? $c->getDiv("Hàbitat:", $boletu->getBoletuHabitat()); ?>
				<? $c->getDiv("Observacions:", $boletu->getBoletuObservation()); ?>
				<? if ($detect->isMobile() || $detect->isTablet()) { ?>
					<div class="options">
						<? if ($sm->hasPermission('edit_boletus') || $boletu->getBoletuUserId() == $_SESSION['info_user']['id']) { ?><input title="<?=_('Editar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Editar...')?>"><? } ?>
						<? if ($sm->hasPermission('remove_boletus') || $boletu->getBoletuUserId() == $_SESSION['info_user']['id']) { ?><input title="<?=_('Eliminar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Eliminar...')?>"><? } ?>
						<input title="<?=_('Sortir');?>" class="button" type="submit" name="selected_action" value="<?=_('Sortir')?>">
						<input type="hidden" name="action" value="1"/>
					</div>
				<? } ?>
				<div class="clear"></div>
			</div>
		</div>
		<input type="hidden" name="action" value="1"/>
	</form>
	
<? $c->getFooter(); ?>
