<?
	/**
	*	Title: Formulari de login
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 18/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	$c = new Content();
	$r = new Redirector();
	$sm = new Security();
	
	// Comprovar la sessió, no cal reautenticar
	if ($sm->isLogged()) { $r->mainRedirect(); }
	
	// Premer el botó per verificar i accedir a l'aplicatiu
	if ($_POST['action']) {
		switch($_POST['selected_action']) {
			case _("Iniciar sessió"):
				session_destroy();
				session_start();
			
				// Comprovem les dades entrades
				$username = trim(substr($_POST['user'],0,50));
				$password = substr($_POST['password'],0,50);
		
				//Comprovar que els camps no estiguin buits
				if (!$username) { $div_user_comment = ERROR_EMPTY; $any_empty = true;}
				if (!$password) { $div_password_comment = ERROR_EMPTY; $any_empty = true;}
				
				// A partir d'aquest punt ja no s'hauria de fer res més si s'ha produit un error anteriorment
				if (!$any_empty) {
					$log = new Logger();
		
					$user = new User($db);
					$user->initWithUsername($username);
					
					if ($user->authenticate($username, $password)) {
						$user->setSession();
										
						$log->logAction('login');
						$r->mainRedirect();
					} else { 
						$info = true;
						$log->logAction('login_error');
					}
				}
				break;
			case _("Registrar-se"):
				$r->redirect('users', 'register.php');
				break;
			case _("Informació iBoletus"):
				$r->redirect('login', 'info.php');
				break;
		}
	}
	
	$div_user = "<div class=\"section_entry\"><label for=\"user\" class=\"login_label_left mandatory\"></label>";
	if ($div_user_comment) $div_user .= "<div class=\"div_input_error\"><input type=\"text\" id=\"user\" name=\"user\" size=\"29\" maxlength=\"50\" placeholder=\"Nom d'usuari\" value=\"".$username."\" /><label class=\"label_error\">".$div_user_comment."</label></div></div>";
		else $div_user .= "<input type=\"text\" id=\"user\" name=\"user\" size=\"29\" maxlength=\"50\" placeholder=\"Nom d'usuari\" value=\"".$username."\" /></div>";
	$div_password = "<div class=\"section_entry\"><label for=\"password\" class=\"login_label_left mandatory\"></label>";
	if ($div_password_comment) $div_password .= "<div class=\"div_input_error\"><input type=\"password\" id=\"password\" name=\"password\" size=\"29\" maxlength=\"50\" placeholder=\"Contrasenya\" value=\"\" /><label class=\"label_error\">".$div_password_comment."</label></div></div>";
		else $div_password .= "<input type=\"password\" id=\"password\" name=\"password\" size=\"29\" maxlength=\"50\" placeholder=\"Contrasenya\" value=\"\" /></div>";

	if ($info) $div_info = "<div class=\"login_info\" style=\"text-align: center\"><label><font style=\"color: red; font-weight: bold\">"._(ERROR_LOGIN)."</font></label></div>";

	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));

?>

	<script>
		window.onload = function() { document.form_user.user.focus(); }
	</script>
	
	<div class="login_header"><p class="login_header_text"><?=_(APP_NAME)?></p></div>
	<?= $div_info; ?>
	<div class="login_section">
		<p class="section_header"><?=_("Entra les teves credencials")?></p>
		<div>
			<form name="form_user" accept-charset="UTF-8" method="post">
				<?= $div_user; ?>
				<?= $div_password; ?>
				<div class="clear" style="padding-top:15px">
					<center>
						<input title="<?=_('Iniciar sessió')?>" class="button" type="submit" name="selected_action" value="<?=_('Iniciar sessió')?>">
						<input title="<?=_('Registrar-se')?>" class="button" type="submit" name="selected_action" value="<?=_('Registrar-se')?>">
					</center>
				</div>
				<div class="clear" style="padding-top:15px">
					<center>
						<input title="<?=_('Informació iBoletus')?>" class="button" type="submit" name="selected_action" value="<?=_('Informació iBoletus')?>">
					</center>
				</div>
				<input type="hidden" name="action" value="1"/>
				<div class="clear"></div>
			</form>
		</div>
	</div>

<? 	$c->getFooter(); ?>
