<?
	/**
	*	Title : Creació d'una nova posició
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 07/12/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();
	
	// Comprovar la sessió, les preferències i els permisos
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	
	$position = new Position($db);
	$fv = new Validator($_POST);

	// Accions amb botons
	if ($_POST['action']) { 
		switch($_POST['selected_action']) {
			case _("Desar"):
				
				$position->setPositionBoletuId($fv->getFormEntry('combobox_boletus_ajax'));
				$position->setPositionDescription($fv->getFormEntry('description', 100));
				$position->setPositionLat($fv->getFormEntry('lat'));
				$position->setPositionLng($fv->getFormEntry('lng'));
				
				$fv->setRestriction('description', RE_ALFANUM, true);
				$fv->setRestriction('lat', RE_NUM_DEC, false);
				$fv->setRestriction('lng', RE_NUM_DEC, false);
				
				$fv->setTest(TEST_SELECT, RE_ID, true, array('combobox_boletus_ajax', TABLE_BOLETUS));

				$fv->validate();
				
				// En aquest punt es consideren les dades correctes i ja es poden desar a la base de dades.
				if ($fv->isFormValid()) {
					$boletu = new Boletu($db);
					$boletu->initWithId($position->getPositionBoletuId());
					$position->setPositionBoletuName($boletu->getBoletuName());
				
					$pos_id = $position->saveToDB();
					$log->logAction('add_position');
					$r->redirect('positions', 'view.php');
				}
				break;
			
			case _("Sortir"):
				$r->redirect('positions', 'view.php');
				break;
		}
	}
			
	// Preparació per la destrucció de les cookies de 'edit' i 'view'
	$cookie_view = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_edit = preg_replace("/view/", "edit", $cookie_view);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME), true);
	$c->getMainHeader(_("Nova localització"));
	require_once(DIRROOT."/scripts/js/ajax.js");
	
?>
	
	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
			
			navigator.geolocation.getCurrentPosition(GetLocation);
			function GetLocation(location) {
			    document.getElementById('latitud').value = location.coords.latitude;
			    document.getElementById('longitud').value = location.coords.longitude;
			}
		}
	</script>
	
	<form class="global" name="form" accept-charset="UTF-8" method="post" enctype="multipart/form-data">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
				<div class="options">
					<input title="<?=_('Desar')?>" class="button" type="submit" name="selected_action" value="<?=_('Desar')?>">
					<input title="<?=_('Sortir')?>" class="button" type="submit" name="selected_action" onClick="deleteCookie('<?=$cookie_view?>', '/'); deleteCookie('<?=$cookie_edit?>', '/');" value="<?=_('Sortir')?>">
				</div>
				<div class="clear"></div>
			</div>
		<? } ?>
		<? if (!$fv->isFormValid()) echo $c->getMessage(INFO_MESSAGE_INVALID_DATA, true); ?>
		<div class="tabbed_box">
			<div class="content_section">
				<?= $c->getAjaxDiv("Bolet:", "boletus", "boletus", "", $fv->getError('combobox_boletus_ajax'), $position->getPositionBoletuId()); ?>
				<? $c->getDiv("Descripció:", $position->getPositionDescription(), "description", EDIT_MODE, FIELD_TEXTAREA, $fv->getError('description')); ?>
				<input type="hidden" id="latitud" name="lat" value=""/>
				<input type="hidden" id="longitud" name="lng" value=""/>
				<? if ($detect->isMobile() || $detect->isTablet()) { ?>
					<div class="options">
						<input title="<?=_('Desar')?>" class="button" type="submit" name="selected_action" value="<?=_('Desar')?>">
						<input title="<?=_('Sortir')?>" class="button" type="submit" name="selected_action" onClick="deleteCookie('<?=$cookie_view?>', '/'); deleteCookie('<?=$cookie_edit?>', '/');" value="<?=_('Sortir')?>">
					</div>
				<? } ?>
				<div class="clear"></div>
			</div>
		</div>
		<input type="hidden" name="action" value="1"/>
	</form>
	
<? $c->getFooter(); ?>
