<?
	/**
	*	Title : Eliminar una posició
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 26/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();
	
	// Comprovar la sessió i els paràmetres d'entrada
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	$sm->isIdValid($_GET['id'], 'positions', 'pos_id') ? $pos_id = $_GET['id'] : $r->returnTo();
	
	$position = new Position($db);
	$position->initWithId($pos_id);
	
	// Comprovar els permisos
	if (!$sm->hasPermission('remove_positions') && $position->getPositionUserId() != $_SESSION['info_user']['id']) $err->showError(ERROR_PERMISSION);
	
	// Accions amb botons
	if ($_POST['action']) {
	
		switch($_POST['selected_action']) {
			
			// Eliminar posició
			case _("Eliminar"):
								
				$position->deleteFromDB();
				unset($position);
				
				$log->logAction('delete_position');
		
				// Redirigir cap a la pàgina anterior si s'ha elimant correctament		
				$r->redirect('positions', 'view.php');
				break;
			
			// Redirigir a la pàgina 'view.php' del mòdul 'positions'
			case _("Sortir"):
				$r->redirect('positions', 'view.php');
				break;
		}
	}
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Eliminar localització"));
	
	if (!$detect->isMobile() && !$detect->isTablet()) { ?>
		<div class="actions">
			<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
			<div class="clear"></div>
		</div>
<?	}

	$c->getDivConfirm(INFO_MESSAGE_DELETE, sprintf("Si us plau, confirma que desitges eliminar definitivament la localització del bolet:<br><br><b>%s</b><br><br>%s<br><br>per a les coordenades (%s, %s)<br>", ht($position->getPositionBoletuName()), ht($position->getPositionDescription()), ht($position->getPositionLat()), ht($position->getPositionLng())), "Eliminar", "Sortir", CONFIRM_DELETE);
	
	$c->getFooter();
?>
