<?
	/**
	*	Title : Edició d'una posició
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 25/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();

	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();
	
	// Comprovar la sessió i els paràmetres d'entrada
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	$sm->isIdValid($_GET['id'], 'positions', 'pos_id') ? $pos_id = $_GET['id'] : $r->returnTo();
	
	$position = new Position($db);
	$position->initWithId($pos_id);
	
	// Comprovar els permisos
	if (!$sm->hasPermission('edit_positions') && $position->getPositionUserId() != $_SESSION['info_user']['id']) $err->showError(ERROR_PERMISSION);

	$fv = new Validator($_POST);
		
	// Accions amb botons
	if ($_POST['action']) { 
		switch($_POST['selected_action']) {
			case _("Desar"):
				
				$position->setPositionBoletuId($fv->getFormEntry('combobox_boletus_ajax'));
				$position->setPositionDescription($fv->getFormEntry('description', 100));
				
				$fv->setRestriction('description', RE_ALFANUM, true);
				
				$fv->setTest(TEST_SELECT, RE_ID, true, array('combobox_boletus_ajax', TABLE_BOLETUS));

				$fv->validate();

				// En aquest punt es consideren les dades correctes i ja es poden desar a la base de dades.
				if ($fv->isFormValid()) {
					$boletu = new Boletu($db);
					$boletu->initWithId($position->getPositionBoletuId());
					$position->setPositionBoletuName($boletu->getBoletuName());
					
					$position->updateInDB();
					$log->logAction('edit_position');
					$r->redirect('positions', 'view.php');
				}
				break;
				
			case _("Sortir"):
				$r->redirect('positions', 'view.php');
				break;
		}
	}
	
	// Preparació per la destrucció de les cookies de 'edit' i 'view'
	$cookie_view = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_edit = preg_replace("/view/", "edit", $cookie_view);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Editar localització"));
	require_once(DIRROOT."/scripts/js/ajax.js");
	
?>
	
	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
		}
	</script>
	
	<form class="global" name="form" accept-charset="UTF-8" method="post" enctype="multipart/form-data">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
				<div class="options">
					<input title="<?=_('Desar')?>" class="button" type="submit" name="selected_action" value="<?=_('Desar')?>">
					<input title="<?=_('Sortir')?>" class="button" type="submit" name="selected_action" onClick="deleteCookie('<?=$cookie_view?>', '/'); deleteCookie('<?=$cookie_edit?>', '/');" value="<?=_('Sortir')?>">
				</div>
				<div class="clear"></div>
			</div>
		<? } ?>
		<? if (!$fv->isFormValid()) echo $c->getMessage(INFO_MESSAGE_INVALID_DATA, 1); ?>
		
		<div class="tabbed_box">
			<div class="content_section">
				<?= $c->getAjaxDiv("Bolet:", "boletus", "boletus", "", $fv->getError('combobox_boletus_ajax'), $position->getPositionBoletuId()); ?>
				<? $c->getDiv("Descripció:", $position->getPositionDescription(), "description", EDIT_MODE, FIELD_TEXTAREA, $fv->getError('description')); ?>
				<? if ($detect->isMobile() || $detect->isTablet()) { ?>
					<div class="options">
						<input title="<?=_('Desar')?>" class="button" type="submit" name="selected_action" value="<?=_('Desar')?>">
						<input title="<?=_('Sortir')?>" class="button" type="submit" name="selected_action" onClick="deleteCookie('<?=$cookie_view?>', '/'); deleteCookie('<?=$cookie_edit?>', '/');" value="<?=_('Sortir')?>">
					</div>
				<? } ?>
				<div class="clear"></div>
			</div>
		</div>
		<input type="hidden" name="action" value="1"/>
	</form>
	
<? $c->getFooter(); ?>
