<?
	/**
	*	Title: Llistat de posicions
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 02/12/2013
	*	Email: vllorente@uoc.edu
	**/
	

	session_start();
	
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$r = new Redirector();
	$sm = new Security();
	
	// Comprovar els paràmetres d'entrada 
	$tok_num = $_GET['tok'];
	
	$fv = new Validator($_GET);
	
	$fv->setRestriction('tok', RE_ID_TOKEN, true);
	
	$fv->validate();
			
	// En aquest punt es consideren les dades correctes
	if ($fv->isFormValid()) {
		
		$db = new Database();
		
		$token = new Token($db);
		$tok_usr_id = $token->checkToken($tok_num);
		
		$user = new User($db);
		$user->initWithId($tok_usr_id);
		
		if ($user->isNotEmpty()) {
			
			$positions = new Positions();
			
			// Obtenim els registres a mostrar
			$positions->getPositionsFromDB($user->getUserId());
			
			// Creació d'una array de strings en format KML
			$kml = array('<?xml version="1.0" encoding="UTF-8"?>');
			$kml[] = '<kml xmlns="http://www.opengis.net/kml/2.2">';
			$kml[] = '<Document>';
			$kml[] = '<name>'.APP_NAME.'</name>';
			$kml[] = '<Style id="pointStyle">';
			$kml[] = '<IconStyle id="pointIcon">';
			$kml[] = '<Icon>';
			$kml[] = '<href>http://maps.google.com/mapfiles/kml/paddle/blu-blank.png</href>';
			$kml[] = '</Icon>';
			$kml[] = '</IconStyle>';
			$kml[] = '</Style>';
			
			// Bucle per generar els Placemark
			foreach ($positions->getPositions() as $pos) { 
			  $kml[] = '<Placemark>';
			  $kml[] = '<name>'.htmlentities($pos->getPositionBoletuName()).'</name>';
			  $kml[] = '<description>'.htmlentities($pos->getPositionDescription()).'</description>';
			  //$kml[] = '<description><![CDATA[<div align="center"><table width="250"><tr><td><img src="'.DIRDATA.'/boletus/'.$pos->getPositionBoletuId().'.jpg" width="250" height="250"></td></tr></table></div>]]></description>';
			  $kml[] = '<styleUrl>#pointStyle</styleUrl>';
			  $kml[] = '<Point>';
			  $kml[] = '<coordinates>'.$pos->getPositionLng(). ','.$pos->getPositionLat().'</coordinates>';
			  $kml[] = '</Point>';
			  $kml[] = '</Placemark>';
			} 
			
			// Final del KML
			$kml[] = '</Document>';
			$kml[] = '</kml>';
			$kmlOutput = join("\n", $kml);
			header('Content-Type: application/vnd.google-earth.kml+xml kml');
		 	header('Content-Disposition: attachment; filename="genkml.kml"');
			
		 	// Eliminar el token de la BD
		 	$tok_id = $token->tokenId($tok_usr_id, $tok_num);
		 	$token->initWithId($tok_id);
			$token->deleteFromDB();
		 	
			echo $kmlOutput;
		}
	}

?>