<?
	/**
	*	Title: Llistat de posicions
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 25/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$positions = new Positions();
	$detect = new MobileDetect();

	// Comprovar la sessió
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	//if (!$sm->hasPermission('list_positions')) $err->showError(ERROR_PERMISSION);
	
	// Si s'ha demanat de visualitzar les posicions no cal fer res més
	if ($_POST['action'] && $_POST['action_view']) $r->redirect('positions', 'view.php');

	// Preparem la taula d'ordenació
	$sortParameters = array ('Bolet' => array ('boletu' => 'pos_bol_name'), 'Descripció' => array ('description' => 'pos_description'));

	// Obtenim el nombre total de registres a mostrar
	$numRecords = $positions->getTotalPositionsFromDB($_SESSION[info_user][id]);
	
	$sorter = new Sorter($_GET, $numRecords, $sortParameters);
	if ($sorter->isPageInvalid()) { $r->redirect('positions', 'main.php'); }
	
	// Obternim els registres a mostrar per pàgina i ordenació
	$positions->getPositionsFromDB($_SESSION[info_user][id]);	

	// Preparem la pàgina de retorn en cas d'errors
	$r->setReturnTo('positions', 'main.php', $sorter->getPage(), $sorter->getOrderBy(), $sorter->getSort());
	
	// Etiqueta amb les opcions del mòdul
	if (!$detect->isMobile() && !$detect->isTablet()) { 
		$div_options = "<div class=\"options\"><input title=\""._("Localitzacions...")."\" class=\"button\" type=\"submit\" name=\"action_view\" value=\""._("Localitzacions...")."\"></div>";
	} else {
		$div_options = "<a href=\"".WWWROOT."/modules/positions/view.php\"><img style=\"float:right; margin-right: 5px\" title=\""._("Localitzacions...")."\" src=\"".IMG_BUTTON_MAP."\"></a>";
	}
		
	// Preparació de les cookies a eliminar
	$cookie = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_view = preg_replace("/main/", "view", $cookie);
	$cookie_edit = preg_replace("/main/", "edit", $cookie);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Llistat de localitzacions"));
	
?>
	
	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
		}
	</script>
	
	<form name="form" accept-charset="UTF-8" method="post">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); 
				echo $div_options; ?>
				<div class="clear"></div>
			</div>
		<? } ?>

		<? $count = (($sorter->getPage() - 1) * DISPLAY_RECORDS) + 1; ?> 
		<? if ($numRecords > 0) { ?>
			<div class="table_section">
				<div class="section_entry"><label class="label_header"><?=_("Localitzacions") ." (".$numRecords.")";?></label></div>
				<? if ($detect->isMobile() || $detect->isTablet()) { echo $div_options; } ?>
				<? if ($numRecords > DISPLAY_RECORDS) echo $sorter->getPaginationDiv(); ?>
				<table width="100%">
					<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
						<tr>
							<td class="table_img_cell""></td>
							<td class="table_img_cell"></td>
							<td></td>
							<td class="table_header"><?=_('Bolet');?></td>
							<td class="table_header"><?=_('Descripció');?></td>
						</tr>
						
						<? foreach ($positions->getPositions() as $position) { ?>
							<tr>
								<td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/positions/edit.php?id=<?=$position->getPositionId()?>"><img title="<?=_('Editar')?>" src="<?=IMG_EDIT?>"/></a></td>
							 	<td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/positions/delete.php?id=<?=$position->getPositionId()?>"><img title="<?=_('Eliminar')?>" src="<?=IMG_DELETE?>"></a></td>
							 	<td class="table_count_cell row<?=$count&1?>"><?=$count?></td>
								<td class="row<?=$count&1?>"><?=ht($position->getPositionBoletuName());?></td>
								<td class="row<?=$count&1?>"><?=ht($position->getPositionDescription());?></td>
							</tr>
						<? $count++; 
						} 
					} else {
						foreach ($positions->getPositions() as $position) { ?>
							<tr>
								<td><a href="<?=WWWROOT?>/modules/positions/edit.php?id=<?=$position->getPositionId()?>"><img title="<?=_('Editar')?>" src="<?=IMG_EDIT?>"/></a></td>
							 	<td><a href="<?=WWWROOT?>/modules/positions/delete.php?id=<?=$position->getPositionId()?>"><img title="<?=_('Eliminar')?>" src="<?=IMG_DELETE?>"></a></td>
								<td>
									<label class="name_title_table"><?=ht($position->getPositionBoletuName());?></label>
									<br>
									<label class="name_subtitle_table"><?=ht($position->getPositionDescription());?></label>
								</td>
							</tr>
						<? 	$count++; 
						} 
					} ?>
				</table>
				<? if ($numRecords > DISPLAY_RECORDS) echo $sorter->getPaginationDiv(); ?>
			</div>
		<? } else { ?>
			<? if ($detect->isMobile() || $detect->isTablet()) { echo $div_options; } ?>
			<div class="no_results"><?=INFO_NO_DATA?></div>
		<? } ?>
		<input type="hidden" name="action" value="1"/>
	</form>

<? $c->getFooter(); ?>
