<?
	/**
	*	Title : Visualitzar un mapa
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 05/12/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$log = new Logger();
	$sm = new Security();
	$c = new Content();
	$detect = new MobileDetect();
	
	// Comprovar la sessió, les preferències i els permisos
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	
	$token = new Token($db);
	$tok_id = $token->saveToDB();
	$token->initWithId($tok_id);
	
	// Si s'ha demanat de crear un nou bolet no cal fer res més
	if ($_POST['action'] && $_POST['action_new']) $r->redirect('positions', 'create.php');
	  
	echo $url = WWWROOT."/modules/positions/genkml.php?tok=".$token->getTokenNum();
	
	// Etiqueta amb les opcions del mòdul
	if (!$detect->isMobile() && !$detect->isTablet()) { 
		$div_options = "<div class=\"options\"><input title=\""._("Nova localització...")."\" class=\"button\" type=\"submit\" name=\"action_new\" value=\""._("Nova localització...")."\"></div>";
	} else {
		$div_options = "<div class=\"options\"><a href=\"".WWWROOT."/modules/positions/create.php\"><img style=\"float:right; margin-right: 5px\" title=\""._("Nova localització...")."\" src=\"".IMG_BUTTON_CREATE."\"></a></div>";
	} 
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME), true);
	$c->getMainHeader(_("Localitzacions"));
	
?>
		
	<script>
		function initialize() {
			if (navigator.geolocation) {
				browserSupportFlag = true;
				navigator.geolocation.getCurrentPosition(function(position) {
					var coord = new google.maps.LatLng(position.coords.latitude,position.coords.longitude);
					var myOptions = {
						zoom: 3,
						center: coord,
						mapTypeId: google.maps.MapTypeId.ROADMAP
					}
					var map = new google.maps.Map(document.getElementById("map"), myOptions);
					var geoXml = new geoXML3.parser({map: map, singleInfoWindow: true});
		        	var jsvar  = "<?= $url; ?>";
					geoXml.parse(jsvar);

					var marker = new google.maps.Marker({
						position: coord,
						map: map,
						title: 'Vostè es troba aquí',
						infoWindow: {
							content: '<p>Vostè es troba aquí!</p>'
						}
					});
			    }, 
			    function() {
				    handleNoGeolocation(browserSupportFlag);
				});
			} else {
				// Browser doesn't support Geolocation
			    browserSupportFlag = false;
			    handleNoGeolocation(browserSupportFlag);
			}
		}
	</script>
	
	<form name="form" accept-charset="UTF-8" method="post">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?> 
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']);
	   			echo $div_options; ?>
				<div class="clear"></div>
			</div>
		<? } ?>
		<div class="tabbed_box">
			<div class="content_section">
				<? if ($detect->isMobile() || $detect->isTablet()) { echo $div_options; } ?>
				<div id="map"></div>
				<div class="clear"></div>
			</div>
		</div>
		<input type="hidden" name="action" value="1"/>
	</form>
	
<? $c->getFooter(); ?>