<?
	/**
	*	Title : Creació d'una nova recepta
	*
	*	Project: iBoletus
	 *	Author: Víctor Llorente Vaquero
	 *	Date: 21/11/2013
	 *	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();

	// Comprovar la sessió, les preferències i els permisos
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	
	$recipe = new Recipe($db);
	$fv = new Validator($_POST);

	// Accions amb botons
	if ($_POST['action']) { 
		switch($_POST['selected_action']) {
			case _("Desar"):
				
				$recipe->setRecipeName($fv->getFormEntry('name', 100));
				$recipe->setRecipeBoletuId($fv->getFormEntry('combobox_boletus_ajax'));
				$recipe->setRecipeIngredient($fv->getFormEntry('ingredient', 4096));
				$recipe->setRecipeDescription($fv->getFormEntry('description', 4096));
				
				$fv->setRestriction('name', RE_ALFANUM, true);
				$fv->setRestriction('ingredient', RE_ALFANUM, true);
				$fv->setRestriction('description', RE_ALFANUM, true);
				
				$fv->setTest(TEST_SELECT, RE_ID, true, array('combobox_boletus_ajax', TABLE_BOLETUS));
				
				$fv->validate();
				
				// En aquest punt es consideren les dades correctes i ja es poden desar a la base de dades.
				if ($fv->isFormValid()) {
					$rec_id = $recipe->saveToDB();
					$log->logAction('add_recipe');
					if (!empty($_FILES['create_photo']['name'])) { add_photo($_FILES['create_photo']['tmp_name'], 'recipes', $rec_id, $_FILES['create_photo']['name']); }
					$r->redirect('recipes', 'view.php', array('id' => $rec_id));
				}
				break;
			
			case _("Sortir"):
				$r->returnTo();
				break;
		}
	}
			
	// Preparació per la destrucció de les cookies de 'edit' i 'view'
	$cookie_view = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_edit = preg_replace("/view/", "edit", $cookie_view);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Nova recepta"));
	require_once(DIRROOT."/scripts/js/ajax.js");
	
?>

	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
		}
	</script>

	<form class="global" name="form" accept-charset="UTF-8" method="post" enctype="multipart/form-data">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
				<div class="options">
					<input title="<?=_('Desar')?>" class="button" type="submit" name="selected_action" value="<?=_('Desar')?>">
					<input title="<?=_('Sortir')?>" class="button" type="submit" name="selected_action" onClick="deleteCookie('<?=$cookie_view?>', '/'); deleteCookie('<?=$cookie_edit?>', '/');" value="<?=_('Sortir')?>">
				</div>
				<div class="clear"></div>
			</div>
		<? } ?>
		<? if (!$fv->isFormValid()) echo $c->getMessage(INFO_MESSAGE_INVALID_DATA, true); ?>
		<div class="tabbed_box">
			<div class="content_section">
				<? $c->getDiv("Nom:", $recipe->getRecipeName(), "name", EDIT_MODE, FIELD_TEXT, $fv->getError('name')); ?>
				<?= $c->getAjaxDiv("Bolet:", "boletus", "boletus", "", $fv->getError('combobox_boletus_ajax'), $recipe->getRecipeBoletuId()); ?>
				<? $c->getDiv("Ingredients:", $recipe->getRecipeIngredient(), "ingredient", EDIT_MODE, FIELD_TEXTAREA, $fv->getError('ingredient')); ?>
				<? $c->getDiv("Elaboració:", $recipe->getRecipeDescription(), "description", EDIT_MODE, FIELD_TEXTAREA, $fv->getError('description')); ?>
				<? $c->getDiv("Fotografia:", $photo, "photo", EDIT_MODE, FIELD_PHOTO, $fv->getError('photo'), "", "create_photo"); ?>
				<? if ($detect->isMobile() || $detect->isTablet()) { ?>
					<div class="options">
						<input title="<?=_('Desar')?>" class="button" type="submit" name="selected_action" value="<?=_('Desar')?>">
						<input title="<?=_('Sortir')?>" class="button" type="submit" name="selected_action" onClick="deleteCookie('<?=$cookie_view?>', '/'); deleteCookie('<?=$cookie_edit?>', '/');" value="<?=_('Sortir')?>">
						<input type="hidden" name="action" value="1"/>
					</div>
				<? } ?>
				<div class="clear"></div>
			</div>
		</div>
		<input type="hidden" name="action" value="1"/>
	</form>
	
<? $c->getFooter(); ?>
