<?
	/**
	*	Title : Eliminar una recepta
	*
	*	Project: iBoletus
	 *	Author: Víctor Llorente Vaquero
	 *	Date: 21/11/2013
	 *	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();
	
	// Comprovar la sessió i els paràmetres d'entrada
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	$sm->isIdValid($_GET['id'], 'recipes', 'rec_id') ? $rec_id = $_GET['id'] : $r->returnTo();
	
	$recipe = new Recipe($db);
	$recipe->initWithId($rec_id);
	
	// Comprovar els permisos
	if (!$sm->hasPermission('remove_recipes') && $recipe->getRecipeUserId() != $_SESSION['info_user']['id']) $err->showError(ERROR_PERMISSION);
	
	// Accions amb botons
	if ($_POST['action']) {
	
		switch($_POST['selected_action']) {
			
			// Eliminar recipe
			case _("Eliminar"):
								
				$recipe->deleteFromDB();
				unset($recipe);
				
				$log->logAction('delete_recipe');
				
				// Eliminar la fotografia del bolet, sempre i quan hi haguí fotografia a la carpeta '/var/iboletusdata/boletus/'
				remove_photo("recipes", $rec_id);
		
				// Redirigir cap a la pàgina anterior si s'ha elimant correctament		
				$r->returnTo();
				break;
			
			// Redirigir a la pàgina 'view.php' del mòdul 'recipes'
			case _("Sortir"):
				$r->redirect('recipes', 'view.php', array('id' => $rec_id));
				break;
		}
	}
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Eliminar recepta"));
	
?>

	<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
		<div class="actions">
			<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
			<div class="clear"></div>
		</div>
	<? } ?>

	<? $c->getDivConfirm(INFO_MESSAGE_DELETE, sprintf("Si us plau, confirma que desitges eliminar definitivament la recepta:<br><br><b>%s</b><br>", ht($recipe->getRecipeName())), "Eliminar", "Sortir", CONFIRM_DELETE); ?>
	
<? 	$c->getFooter(); ?>
