<?
	/**
	*	Title: Llistat de les receptes
	*
	*	Project: iBoletus
	 *	Author: Víctor Llorente Vaquero
	 *	Date: 21/11/2013
	 *	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$r = new Redirector();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();

	// Comprovar la sessió, les preferències i els permisos
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	
	$c = new Content();
	$recipes = new Recipes();
	
	// Si s'ha demanat de crear una nova recepta no cal fer res més
	if ($_POST['action'] && $_POST['action_new']) $r->redirect('recipes', 'create.php');

	// Preparem la taula d'ordenació
	$sortParameters = array ('Recepta' => array ('name' => 'rec_name'), 'Bolet' => array ('bolet' => 'rec_bol_id'), 'Autor' => array('user' => 'rec_usr_id'), 'Data publicació' => array ('date' => 'rec_date'));

	// Obtenim el nombre total de registres a mostrar
	$numRecords = $recipes->getTotalRecipesFromDB();
	
	$sorter = new Sorter($_GET, $numRecords, $sortParameters);
	if ($sorter->isPageInvalid()) { $r->redirect('recipes', 'main.php'); }
	
	// Obtenim els registres a mostrar per pàgina i ordenació
	$recipes->getRecipesFromDB($sorter->getModQueryOrder(), $sorter->getPage());

	// Preparem la pàgina de retorn en cas d'errors
	$r->setReturnTo('recipes', 'main.php', $sorter->getPage(), $sorter->getOrderBy(), $sorter->getSort());
	
	// Etiqueta amb les opcions del mòdul
	if (!$detect->isMobile() && !$detect->isTablet()) { 
		$div_options = "<div class=\"options\"><input title=\""._("Nova recepta...")."\" class=\"button\" type=\"submit\" name=\"action_new\" value=\""._("Nova recepta...")."\"></div>";
	} else {
		$div_options = "<div class=\"options\"><a href=\"".WWWROOT."/modules/recipes/create.php\"><img style=\"float:right; margin-right: 5px\" title=\""._("Nova recepta...")."\" src=\"".IMG_BUTTON_CREATE."\"></a></div>";
	}
		
	// Preparació de les cookies a eliminar
	$cookie = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_view = preg_replace("/main/", "view", $cookie);
	$cookie_edit = preg_replace("/main/", "edit", $cookie);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Llistat de receptes"));
	
?>
	
	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
		}
	</script>
	
	<form name="form" accept-charset="UTF-8" method="post">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); 
				echo $div_options; ?>
				<div class="clear"></div>
			</div>
		<? } ?>
		<? $count = (($sorter->getPage() - 1) * DISPLAY_RECORDS) + 1; ?> 
		<? if ($numRecords > 0) { ?>
			<div class="table_section">
				<div class="section_entry"><label class="label_header"><?=_("Receptes") ." (".$numRecords.")";?></label></div>
				<? if ($detect->isMobile() || $detect->isTablet()) { echo $div_options; } ?>
				<? if ($numRecords > DISPLAY_RECORDS) echo $sorter->getPaginationDiv(); ?>
				<table width="100%">
					<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
						<tr>
							<td class="table_img_cell"></td>
							<?	if ($sm->hasPermission('edit_recipes')) { ?><td class="table_img_cell""></td><? } ?>
							<?	if ($sm->hasPermission('remove_recipes')) { ?><td class="table_img_cell"></td><? } ?>
							<td></td>
							<td class="table_header"><?=_('Recepta');?></td>
							<td class="table_header"><?=_('Bolet');?></td>
							<td class="table_header"><?=_('Autor');?></td>
							<td nowrap class="table_header"><?=_('Data publicació');?></td>
						</tr>
						
						<? foreach ($recipes->getRecipes() as $recipe) { ?>
							<tr>
								<td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/recipes/view.php?id=<?=$recipe->getRecipeId();?>"><img title="<?=_('Visualitzar')?>" src="<?=IMG_VIEW?>"/></a></td>
								<? if ($sm->hasPermission('edit_recipes')) { ?><td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/recipes/edit.php?id=<?=$recipe->getRecipeId()?>"><img title="<?=_('Editar')?>" src="<?=IMG_EDIT?>"/></a></td><? } ?>
							 	<? if ($sm->hasPermission('remove_recipes')) { ?><td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/recipes/delete.php?id=<?=$recipe->getRecipeId()?>"><img title="<?=_('Eliminar')?>" src="<?=IMG_DELETE?>"></a></td><? } ?>
								<td class="table_count_cell row<?=$count&1?>"><?=$count?></td>
								<td class="row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/recipes/view.php?id=<?=$recipe->getRecipeId()?>"><?=ht($recipe->getRecipeName());?></a></td>
								<td class="row<?=$count&1?>"><?=ht($recipe->getRecipeBoletuFullName());?></td>
								<td class="row<?=$count&1?>"><?=ht($recipe->getRecipeUserFullName());?></td>
								<td nowrap class="row<?=$count&1?>"><?=ht(format_date_number(get_ISO_date($recipe->getRecipeDate())));?></td>
							</tr>
						<?	$count++; 
						   }
						} else {
							foreach ($recipes->getRecipes() as $recipe) { ?>
								<tr>
									<td><a href="<?=WWWROOT?>/modules/recipes/view.php?id=<?=$recipe->getRecipeId();?>"><img src="<?=view_photo('recipes', $recipe->getRecipeId(), 100, 100);?>"></a></td>
									<td>
										<label class="name_title_table"><?=ht($recipe->getRecipeName());?></label>
										<br>
										<label class="name_subtitle_table"><?=ht($recipe->getRecipeBoletuFullName());?></label>
									</td>
								</tr>
							<? 	$count++; 
							} 
						} ?>
				</table>
				<? if ($numRecords > DISPLAY_RECORDS) echo $sorter->getPaginationDiv(); ?>
			</div>
		<? } else { ?>
			<? if ($detect->isMobile() || $detect->isTablet()) { echo $div_options; } ?>
			<div class="no_results"><?=INFO_NO_DATA?></div>
		<? } ?>
		<input type="hidden" name="action" value="1"/>
	</form>

<? $c->getFooter(); ?>
