<?
	/**
	*	Title : Visualització d'una recepta
	*
	*	Project: iBoletus
	*	Author: Víctor Llorente Vaquero
	*	Date: 21/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();
	
	// Comprovar la sessió, les preferències i els permisos
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	
	// Comprovar els paràmetres d'entrada
	$sm->isIdValid($_GET['id'], 'recipes', 'rec_id') ? $rec_id = $_GET['id'] : $r->returnTo();
	
	// Accions amb botons
	if ($_POST['action']) { 
		switch($_POST['selected_action']) {
			case _("Editar..."): $r->redirect('recipes', 'edit.php', array (id => $rec_id)); break;
			case _("Eliminar..."): $r->redirect('recipes', 'delete.php', array (id => $rec_id)); break;
			case _("Sortir"): $r->returnTo(); break;
		}
	}
	
	$recipe = new Recipe($db);
	$recipe->initWithId($rec_id);
	
	$user = new User($db);
	$user->initWithId($recipe->getRecipeUserId());
			
	// Preparació per la destrucció de les cookies de 'edit' i 'view'
	$cookie_view = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_edit = preg_replace("/view/", "edit", $cookie_view);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Visualitzar recepta"));
	
?>

	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
		}
	</script>
	
	<form class="global" name="form" accept-charset="UTF-8" method="post">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
				<div class="options">
					<? if ($sm->hasPermission('edit_recipes') || $recipe->getRecipeUserId() == $_SESSION['info_user']['id']) { ?><input title="<?=_('Editar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Editar...')?>"><? } ?>
					<? if ($sm->hasPermission('remove_recipes') || $recipe->getRecipeUserId() == $_SESSION['info_user']['id']) { ?><input title="<?=_('Eliminar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Eliminar...')?>"><? } ?>
					<input title="<?=_('Sortir');?>" class="button" type="submit" name="selected_action" value="<?=_('Sortir')?>">
				</div>
				<div class="clear"></div>
			</div>
		<? } ?>

		<div class="tabbed_box">
			<div class="content_section">
				<? $c->getSectionHeader($recipe->getRecipeName()); ?>
				<? $c->getDiv("", view_photo('recipes', $rec_id, PHOTO_WIDTH, PHOTO_HEIGHT), "", VIEW_MODE, FIELD_PHOTO); ?>
				<? $c->getDiv("Bolet:", $recipe->getRecipeBoletuFullName(), "", VIEW_MODE, FIELD_LINK, "", $recipe->getRecipeBoletuId(), "boletus"); ?>
				<? if ($user->isNotEmpty()) $c->getDiv("Autor:", $recipe->getRecipeUserFullName()); ?>
				<? $c->getDiv("Publicació:", format_date(get_ISO_date($recipe->getRecipeDate()))); ?>
				<? $c->getDiv("Ingredients:", $recipe->getRecipeIngredient(), "", VIEW_MODE, FIELD_TEXTAREA); ?>
				<? $c->getDiv("Elaboració:", $recipe->getRecipeDescription(), "", VIEW_MODE, FIELD_TEXTAREA); ?>
				<? if ($detect->isMobile() || $detect->isTablet()) { ?>
					<div class="options">
						<? if ($sm->hasPermission('edit_recipes') || $recipe->getRecipeUserId() == $_SESSION['info_user']['id']) { ?><input title="<?=_('Editar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Editar...')?>"><? } ?>
						<? if ($sm->hasPermission('remove_recipes') || $recipe->getRecipeUserId() == $_SESSION['info_user']['id']) { ?><input title="<?=_('Eliminar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Eliminar...')?>"><? } ?>
						<input title="<?=_('Sortir');?>" class="button" type="submit" name="selected_action" value="<?=_('Sortir')?>">
						<input type="hidden" name="action" value="1"/>
					</div>
				<? } ?>
				<div class="clear"></div>
			</div>
		</div>
		<input type="hidden" name="action" value="1"/>
	</form>
	
<? $c->getFooter(); ?>
