<?
	/**
	*	Title : Cercar a la base de dades, segons el valor que li passem i el mòdul que específiquem
	*
	*	Content: el text que s'introdueix no pot contenir menys de tres caràcters, per tant, es descarta.
	* 	Es separar el text per paraules.
	* 	És cercar globalment, desprès cerquem per permutacions i a continuació de forma individual
	*	El resultat obtingut es trobar en una taula on s'hi han repetit resultat, per l'acumulació,
	* 	es fa una comparativa d'aquests resultats obtinguts i s'enregistrar en una nova taula els
	* 	resultats de la cercar sense estar repetits.
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 04/12/2013
	*	Email: vllorente@uoc.edu
	**/

	session_start();
	
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$support = new Support();
	$detect = new MobileDetect();
	
	// Comprovar la sessió, les preferències i els permisos
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	if (!$detect->isMobile() && !$detect->isTablet()) { $log->logAction('session_error'); $r->loginRedirect(); }
	
	// Assignar el mòdul de la cercar a una variable
	if (!empty($_POST['select_module_search'])) $module = $_POST['select_module_search']; else $module = $_SESSION['module'];
	
	// Verificar els permisos de l'usuari segons el mòdul seleccionat
	if (!$sm->hasPermission('search_users') && $module == "users") $err->showError(ERROR_PERMISSION);
	if ($module == "positions") $err->showError(ERROR_PERMISSION);
	
	// Verificar que es disposar del mòdul on poder realitzar la cercar, sinó retornar a la 
	// pàgina principal '/modules/login/main.php' o bé, guardar en una variable de sessió el 
	// mòdul on hem realitzat la darrera cercar
	if ($module == -1) $r->mainRedirect(); else $_SESSION['module'] = $module;
	
	// Obtenir els valors de la cercar de la variable de sessió
	$searchArray = $_SESSION['search'];
	
	$search = new Search();
	$fv = new Validator($_POST);
	
	// Accions amb botons
	if (($_POST['action'] && $_POST['query'] != "") || $searchArray) { 
		switch($_POST['selected_action']) {
			case _("Cercar"):
				
				// Condició per a una nova cercar segons la cadena introduïda, en cas que no s'hagi entrat res, cercar segons la variable $_SESSION['search']
				// Separem cada paraula dins d'una array
				if ($searchArray != $_POST['query'] && $_POST['query'] != "") $searchArray = explode(" ", substr(trim($_POST['query']), 0, 50));
				
				// Enregistrar els valors en una variable de sessió, que posteriorment és recuperaran quan es torni enrera
				$_SESSION['search'] = $searchArray;
				
				// Validar els valors introduïts
				if (isset($searchArray)) {
					
					for ($x = 0; $x < count($searchArray); $x++) {
						$fv->setRestriction($searchArray[$x], RE_DATE_FW, true);
						$fv->setRestriction($searchArray[$x], RE_ALFANUM, true);
						$fv->validate();
						if ($fv->isFormValid()) unset($searchArray[$x]);
					}
					
					if (isset($searchArray)) {
						foreach ($searchArray as $sa) {
							 
							// Eliminem les paraules menors de 3 lletres (s'inclouen els camps buits)
							$fv->setRestriction($sa, RE_DATE_FW, true);
							$fv->validate();
							if (strlen($sa) > 2 && !$fv->isFormValid()) $valors[] = $sa;
							
							// Separar i invertir el ordre de la data, de 'dd/mm/yyyy' a 'yyyy-mm-dd'
							if ($fv->isFormValid()) {
								$date = explode("/", $sa);
								switch (count($date)) {
									case 2: $valors[] = $date[1]."-".$date[0]; break; // Format 'yyyy-mm'
									case 3: $valors[] = $date[2]."-".$date[1]."-".$date[0]; break; // Format 'yyyy-mm-dd'
								}
							}
						}
						
						unset($searchArray);
					} else {
						$r->mainRedirect();
					}
				} else {
					$r->mainRedirect();
				}
				
				// Evitar l'entrada per URL de paràmetres per part dels usuaris (lletres i valors negatius)
				$fv->setRestriction('page', RE_NUM, true);
				$fv->validate();
				if ($_GET['page'] != 0 && $fv->isFormValid()) $page = $_GET['page']; else $page = 1;	
				
				// Evitar l'entrada per URL de paràmetres per part dels usuaris al camp 'sort'
				if ($_GET['sort'] == "asc" || $_GET['sort'] == "desc") $sort = $_GET['sort'];
				
				$start = ($page - 1) * DISPLAY_RECORDS;
				
				// Cercar
				$search->getSearchFromDB($module, $valors, $sort, $start);
				
				break;
		}	
	}
	
	// Preparem la taula d'ordenació
	switch ($module) {
		case "boletus": $sortParameters = array ('Bolet' => array ('name' => 'bol_name'), 'Nom en llatí' => array ('latin' => 'bol_name_latin'), 'Comestible' => array ('toxic' => 'bol_toxic')); break;
		case "recipes": $sortParameters = array ('Recepta' => array ('name' => 'rec_name'), 'Bolet' => array ('bolet' => 'rec_bol_id'), 'Autor' => array('user' => 'rec_usr_id'), 'Data publicació' => array ('date' => 'rec_date')); break;
		case "users": $sortParameters = array ('Primer cognom' => array ('first' => 'usr_first_last_name'), 'Segon cognom' => array ('second' => 'usr_second_last_name'), 'Nom' => array ('name' => 'usr_name')); break;
		default: $sortParameters = array(); break;
	}

	// Obtenim el nombre total de registres
	$numRecords = $search->getCount();
	
	$sorter = new Sorter($_GET, $numRecords, $sortParameters);
	if ($sorter->isPageInvalid()) $r->redirect($module, 'main.php');

	// Preparem la pàgina de retorn en cas d'errors
	$r->setReturnTo('search', 'search_mobile.php', $sorter->getPage(), $sorter->getOrderBy(), $sorter->getSort());
	
	$row_module = $support->getSearchModules();
	
	// Preparació de les cookies a eliminar
	$cookie = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_view = preg_replace("/main/", "view", $cookie);
	$cookie_edit = preg_replace("/main/", "edit", $cookie);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Cercar"));
	
?>
	
	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
		}
	</script>

	<form name="form_search" accept-charset="UTF-8" method="post">
		<div class="tabbed_box">
			<div class="content_section">
				<? if ($numRecords == 0) { $c->getDiv("Cercar", $row_module, "select_module_search", EDIT_MODE, FIELD_SELECT_SEARCH, 0); }?>
				<? $count = (($sorter->getPage() - 1) * DISPLAY_RECORDS) + 1; ?> 
				<? if ($numRecords > 0) { ?>
					<div class="section_entry"><label class="label_header"><?=_("Resultats de la cerca") ." (".$numRecords.")";?></label></div>
					<?	if ($numRecords > DISPLAY_RECORDS) echo $sorter->getPaginationDiv(); ?>
					<table width="100%">
						<? foreach ($search->getSearch() as $sea) { ?>
							<tr>
								<?	switch ($module) {
										case "boletus": ?>
											<td><a href="<?=WWWROOT?>/modules/boletus/view.php?id=<?=$sea->getBoletuId();?>"><img src="<?=view_photo('boletus', $sea->getBoletuId(), 100, 100);?>"></a></td>
											<td>
												<label class="name_title_table"><?=ht($sea->getBoletuName());?></label>
												<br>
												<label class="name_subtitle_table"><?=ht($sea->getBoletuNameLatin());?></label>
											</td>
								<?			break;
										case "recipes": ?>
											<td><a href="<?=WWWROOT?>/modules/recipes/view.php?id=<?=$sea->getRecipeId();?>"><img src="<?=view_photo('recipes', $sea->getRecipeId(), 100, 100);?>"></a></td>
											<td>
												<label class="name_title_table"><?=ht($sea->getRecipeName());?></label>
												<br>
												<label class="name_subtitle_table"><?=ht($sea->getRecipeBoletuName());?></label>
											</td>
								<?			break;
										case "users": ?>
											<td class="row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/users/view.php?id=<?=$sea->getUserId();?>"><img title="<?=_('Visualitzar')?>" src="<?=IMG_VIEW?>"/></a></td>
											<? if ($sm->hasPermission('edit_users')) { ?><td class="row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/users/edit.php?id=<?=$sea->getUserId()?>"><img title="<?=_('Editar')?>" src="<?=IMG_EDIT?>"/></a></td><? } ?>
										 	<? if ($sm->hasPermission('remove_users')) { ?><td class="row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/users/delete.php?id=<?=$sea->getUserId()?>"><img title="<?=_('Eliminar')?>" src="<?=IMG_DELETE?>"></a></td><? } ?>
										 	<td class="row<?=$count&1?>"><?=$count?></td>
											<td><a href="<?=WWWROOT?>/modules/users/view.php?id=<?=$sea->getUserId()?>"><?=ht($sea->getUserFullNameList());?></a></td>
								<?			break;
									} ?>
							</tr>
						<? 	$count++; 
						} ?>
					</table>
					<? if ($numRecords > DISPLAY_RECORDS) echo $sorter->getPaginationDiv(); ?>
				<? } else { ?>
					<label class="info_no_data_search"><?=INFO_NO_DATA?></label>
				<? } ?>
				<div class="clear"></div>
			</div>
		</div>
		<input type="hidden" name="action" value="1"/>
	</form>

<? $c->getFooter(); ?>
