<?
	/**
	*	Title : Eliminar un usuari
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 18/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$detect = new MobileDetect();
		
	// Comprovar la sessió i els paràmetres d'entrada
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	$sm->isIdValid($_GET['id'], 'users', 'usr_id') ? $usr_id = $_GET['id'] : $r->returnTo();
	
	// Comprovar els permisos
	if (!$sm->hasPermission('remove_users') && $usr_id != $_SESSION['info_user']['id']) $err->showError(ERROR_PERMISSION);
	
	$user = new User($db);
	$user->initWithId($usr_id);
	
	// Accions amb botons
	if ($_POST['action']) { 
	
		switch($_POST['selected_action']) {
			
			// Eliminar l'usuari
			case _("Eliminar"):
								
				$user->deleteFromDB();
				
				$log->logAction('delete_user');
				
				if ($user->isNotEmpty() && $usr_id == $_SESSION['info_user']['id']) {
					unset($_SESSION['info_user']);
					unset($_SESSION['return_to']);
					unset($user);
					
					// Redirigir cap a la pàgina d'accés
					$r->loginRedirect();
				} else {
					unset($user);
					
					// Redirigir cap a la pàgina anterior si s'ha elimant correctament		
					$r->returnTo();
				}
				break;
			
			// Redirigir a la pàgina 'view.php' del mòdul 'users'
			case _("Sortir"):
				$r->redirect('users', 'view.php', array('id', $usr_id));
				break;
		}
	}
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Eliminar usuari"));
	
?>

	<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
		<div class="actions">
			<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
			<div class="clear"></div>
		</div>
	<? } ?>

	<? $c->getDivConfirm(INFO_MESSAGE_DELETE, sprintf("Si us plau, confirma que desitges eliminar definitivament l'usuari:<br><br><b>%s</b><br><br><mark>IMPORTANT:</mark> No es podrà tornar a accedir a l'aplicació amb aquest usuari.", ht($user->getUserFullName())), "Eliminar", "Sortir", CONFIRM_DELETE); ?>
	
<? 	$c->getFooter(); ?>
