<?
	/**
	*	Title: Llistat d'usuaris
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 18/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$users = new Users();
	$detect = new MobileDetect();

	// Comprovar la sessió
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	if (!$sm->hasPermission('list_users')) $err->showError(ERROR_PERMISSION);
	
	// Si s'ha demanat de crear un nou usuari no cal fer res més
	if ($_POST['action'] && $_POST['action_new']) $r->redirect('users', 'create.php');

	// Preparem la taula d'ordenació
	$sortParameters = array ('Primer cognom' => array ('first' => 'usr_first_last_name'), 'Segon cognom' => array ('second' => 'usr_second_last_name'), 'Nom' => array ('name' => 'usr_name'));

	// Obtenim el nombre total de registres a mostrar
	$numRecords = $users->getTotalUsersFromDB();
	
	$sorter = new Sorter($_GET, $numRecords, $sortParameters);
	if ($sorter->isPageInvalid()) { $r->redirect('users', 'main.php'); }
	
	// Obternim els registres a mostrar per pàgina i ordenació
	$users->getUsersFromDB($sorter->getModQueryOrder(), $sorter->getPage());	

	// Preparem la pàgina de retorn en cas d'errors
	$r->setReturnTo('users', 'main.php', $sorter->getPage(), $sorter->getOrderBy(), $sorter->getSort());
	
	// Etiqueta amb les opcions del mòdul
	if ($sm->hasPermission('new_users')) {
		if (!$detect->isMobile() && !$detect->isTablet()) { 
			$div_options = "<div class=\"options\"><input title=\""._("Nou usuari...")."\" class=\"button\" type=\"submit\" name=\"action_new\" value=\""._("Nou usuari...")."\"></div>";
		} else {
			$div_options = "<div class=\"options\"><a href=\"".WWWROOT."/modules/users/create.php\"><img style=\"float:right; margin-right: 5px\" title=\""._("Nou usuari...")."\" src=\"".IMG_BUTTON_CREATE."\"></a></div>";
		}
	}
		
	// Preparació de les cookies a eliminar
	$cookie = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_view = preg_replace("/main/", "view", $cookie);
	$cookie_edit = preg_replace("/main/", "edit", $cookie);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Llistat d'usuaris"));
	
?>
	
	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/'); 
			deleteCookie('<?= $cookie_edit;?>', '/');
		}
	</script>
	
	<form name="form" accept-charset="UTF-8" method="post">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); 
				echo $div_options; ?>
				<div class="clear"></div>
			</div>
		<? } ?>

		<? $count = (($sorter->getPage() - 1) * DISPLAY_RECORDS) + 1; ?> 
		<? if ($numRecords > 0) { ?>
			<div class="table_section">
				<div class="section_entry"><label class="label_header"><?=_("Usuaris") ." (".$numRecords.")";?></label></div>
				<? if ($detect->isMobile() || $detect->isTablet()) { echo $div_options; } ?>
				<? if ($numRecords > DISPLAY_RECORDS) echo $sorter->getPaginationDiv(); ?>
				<table width="100%">
					<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
						<tr>
							<td class="table_img_cell"></td>
							<?	if ($sm->hasPermission('edit_users')) { ?><td class="table_img_cell""></td><? } ?>
							<?	if ($sm->hasPermission('remove_users')) { ?><td class="table_img_cell"></td><? } ?>
							<td></td>
							<td nowrap class="table_header"><?=_('Primer cognom');?> <?=_('Segon cognom');?>, <?=_('Nom');?></td>
						</tr>
						
						<? foreach ($users->getUsers() as $user) { ?>
							<tr>
								<td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/users/view.php?id=<?=$user->getUserId();?>"><img title="<?=_('Visualitzar')?>" src="<?=IMG_VIEW?>"/></a></td>
								<? if ($sm->hasPermission('edit_users')) { ?><td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/users/edit.php?id=<?=$user->getUserId()?>"><img title="<?=_('Editar')?>" src="<?=IMG_EDIT?>"/></a></td><? } ?>
							 	<? if ($sm->hasPermission('remove_users')) { ?><td class="table_img_cell row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/users/delete.php?id=<?=$user->getUserId()?>"><img title="<?=_('Eliminar')?>" src="<?=IMG_DELETE?>"></a></td><? } ?>
							 	<td class="table_count_cell row<?=$count&1?>"><?=$count?></td>
								<td class="row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/users/view.php?id=<?=$user->getUserId()?>"><?=ht($user->getUserFullNameList());?></a></td>
							</tr>
						<? $count++; 
						} 
					} else {
						foreach ($users->getUsers() as $user) { ?>
							<tr>
								<td class="row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/users/view.php?id=<?=$user->getUserId();?>"><img title="<?=_('Visualitzar')?>" src="<?=IMG_VIEW?>"/></a></td>
								<? if ($sm->hasPermission('edit_users')) { ?><td class="row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/users/edit.php?id=<?=$user->getUserId()?>"><img title="<?=_('Editar')?>" src="<?=IMG_EDIT?>"/></a></td><? } ?>
							 	<? if ($sm->hasPermission('remove_users')) { ?><td class="row<?=$count&1?>"><a href="<?=WWWROOT?>/modules/users/delete.php?id=<?=$user->getUserId()?>"><img title="<?=_('Eliminar')?>" src="<?=IMG_DELETE?>"></a></td><? } ?>
							 	<td class="row<?=$count&1?>"><?=$count?></td>
								<td><a href="<?=WWWROOT?>/modules/users/view.php?id=<?=$user->getUserId()?>"><?=ht($user->getUserFullNameList());?></a></td>
							</tr>
						<? 	$count++; 
						} 
					} ?>
				</table>
				<? if ($numRecords > DISPLAY_RECORDS) echo $sorter->getPaginationDiv(); ?>
			</div>
		<? } else { ?>
			<? if ($detect->isMobile() || $detect->isTablet()) { echo $div_options; } ?>
			<div class="no_results"><?=INFO_NO_DATA?></div>
		<? } ?>
		<input type="hidden" name="action" value="1"/>
	</form>

<? $c->getFooter(); ?>
