<?
	/**
	*	Title : Visualització d'un usuari
	*
	*	Project: iBoletus
	*	Author: Victor Llorente Vaquero
	*	Date: 18/11/2013
	*	Email: vllorente@uoc.edu
	**/
	
	session_start();
	
	// Incloem les funcions
	require_once(dirname(__FILE__) . "/../../config.php");
	require_once(DIRLIB."/".APP.".php");
	
	$db = new Database();
	
	$r = new Redirector();
	$c = new Content();
	$log = new Logger();
	$sm = new Security();
	$err = new Error();
	$support = new Support();
	$detect = new MobileDetect();
	
	// Comprovar la sessió i els paràmetres d'entrada
	if (!$sm->isLogged()) { $log->logAction('session_error'); $r->loginRedirect(); }
	$sm->isIdValid($_GET['id'], 'users', 'usr_id') ? $usr_id = $_GET['id'] : $r->returnTo();
	
	// Comprovar els permisos
	if (!$sm->hasPermission('view_users') && $usr_id != $_SESSION['info_user']['id']) $err->showError(ERROR_PERMISSION);
	
	// Accions amb botons
	if ($_POST['action']) { 
		switch($_POST['selected_action']) {
			case _("Editar..."): $r->redirect('users', 'edit.php', array ('id' => $usr_id)); break;
			case _("Eliminar..."): $r->redirect('users', 'delete.php', array ('id' => $usr_id)); break;
			case _("Sortir"): $r->returnTo(); break;
		}
	}
	
	$user = new User($db);
	$user->initWithId($usr_id);
	
	// Preparació per la destrucció de les cookies de 'edit' i 'view'
	$cookie_view = preg_replace("/[\/\.]/", "", $_SERVER['PHP_SELF']);
	$cookie_edit = preg_replace("/view/", "edit", $cookie_view);
	
	// Inici creació de la pàgina
	$c->getHeader(_(APP_NAME));
	$c->getMainHeader(_("Visualitzar usuari"));
	
?>

	<script>
		window.onload = function() {
			deleteCookie('<?= $cookie_view;?>', '/');
		}
	</script>
	
	<form class="global" name="form" accept-charset="UTF-8" method="post">
		<? if (!$detect->isMobile() && !$detect->isTablet()) { ?>
			<div class="actions">
				<? $c->getNavigation($_SERVER['PHP_SELF']); ?>
				<div class="options">
					<? if ($sm->hasPermission('edit_users') || $usr_id == $_SESSION['info_user']['id']) { ?><input title="<?=_('Editar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Editar...')?>"><? } ?>
					<? if ($sm->hasPermission('remove_users') || $usr_id == $_SESSION['info_user']['id']) { ?><input title="<?=_('Eliminar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Eliminar...')?>"><? } ?>
					<input title="<?=_('Sortir');?>" class="button" type="submit" name="selected_action" value="<?=_('Sortir')?>">
				</div>
				<div class="clear"></div>
			</div>
		<? } ?>
		
		<div class="tabbed_box">
			<div class="content_section">
				<? $c->getSectionHeader("Dades personals"); ?>
				<? $c->getDiv("Nom:", $user->getUserFullName()); ?>
				<? $c->getDiv("Sexe:", $support->getSystemValueByType('gender', $user->getUserGender())); ?>
				<? $c->getDiv("País:", $support->getSystemValueByType('country', $user->getUserCountry())); ?>
				<? $c->getDiv("Telèfon:", $user->getUserPhone()); ?>
				<? $c->getDiv("Adreça electrònica:", $user->getUserEmail()); ?>
				<? $c->getDiv("Data d'alta:", format_date($user->getUserDateCreated())); ?>
				<? $c->getSectionHeader("Dades del compte"); ?>
				<? $c->getDiv("Nom d'usuari:", $user->getUserUsername()); ?>
				<? $c->getDiv("Perfil:", $support->getRoleNameById($user->getUserRole())); ?>
				<? if ($detect->isMobile() || $detect->isTablet()) { ?>
					<div class="options">
						<? if ($sm->hasPermission('edit_users') || $usr_id == $_SESSION['info_user']['id']) { ?><input title="<?=_('Editar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Editar...')?>"><? } ?>
						<? if ($sm->hasPermission('remove_users') || $usr_id == $_SESSION['info_user']['id']) { ?><input title="<?=_('Eliminar...');?>" class="button" type="submit" name="selected_action" value="<?=_('Eliminar...')?>"><? } ?>
						<input title="<?=_('Sortir');?>" class="button" type="submit" name="selected_action" value="<?=_('Sortir')?>">
					</div>
				<? } ?>
				<div class="clear"></div>
			</div>
		</div>
		<input type="hidden" name="action" value="1"/>
	</form>
	
<? $c->getFooter(); ?>
