<?
	/**
	*	Title:		Funcions per defecte de tipus ajax per a crear objectes
	*
	*	Project: 	iBoletus
	*	Author: 	Victor Llorente Vaquero
	*	Date:		21/11/2013
	*	Email:		vllorente@uoc.edu
	**/
?>

<script>

	var xmlHttp;
	
	// Funció que segons del tipus de navegador, crear un objecte o un altre
	function GetXmlHttpObject() {
		// code for IE7+, Firefox, Chrome, Opera, Safari
		if (window.XMLHttpRequest) return new XMLHttpRequest();
		
		// code for IE6, IE5
		if (window.ActiveXObject) return new ActiveXObject("Microsoft.XMLHTTP");
		
		return null;
	}
	
	// Acceptar els accents l'ajax als diferents navegadors
	function isIE() {
		return /msie/i.test(navigator.userAgent) && !/opera/i.test(navigator.userAgent);
	}
	
	function encode_utf8(s)	{
		return unescape(encodeURIComponent(s));
	}
	
	function decode_utf8(s)	{
		return decodeURIComponent(escape(s));
	}
	
	// Funció que recuperar el valor que es vol cercar, i cridar l'arxiu 'ajax.php' enviant per URL el
	// paràmetre corresponen a la string que volem cercar, al mateix temps crida la funció stateChanged()
	// per a mostrar el resultat a l'arxiu on es trobar la crida de la funció showResult(str, module, name, type).
	function showResult(str, module, name) {
		xmlHttp = GetXmlHttpObject();
		
		if (xmlHttp == null) {
			alert ("El seu navegador no suporta XML HTTP Request");
			return;
		}
		
		var url = "../ajax/ajax.php?value=" + str + "&module=" + module;
		
		if (isIE()) {
			xmlHttp.open("GET", encode_utf8(url));
		} else {
			xmlHttp.open("GET", url);
		}
		xmlHttp.onreadystatechange = function(){
			// El número quatre representa que esta complet, es un valor fixe i definit internament a Ajax
			if (xmlHttp.readyState == 4 || xmlHttp.readyState=="complete") {
				
				var xmlDoc = loadXMLString(xmlHttp.responseText);
				var inner = "";
				
				inner = "<select name=\"combobox_" + name + "_ajax\"><option value='-1'><?=_(' - Escolliu una opció - ')?></option>";
				
				for (var j = 0; j < xmlDoc.getElementsByTagName("element").length; j++) {
					
					inner = inner + "<option ";
					
					if (xmlDoc.documentElement.getElementsByTagName("id")[j].hasChildNodes()) {
						var id = xmlDoc.documentElement.getElementsByTagName("id")[j].firstChild.nodeValue;
						inner = inner + "value=\"" + id + "\">";
					}
					
					if (xmlDoc.documentElement.getElementsByTagName("description")[j].hasChildNodes()) {
						var description = xmlDoc.documentElement.getElementsByTagName("description")[j].firstChild.nodeValue;
						inner = inner + description;
					}
					
					inner = inner + "</option>";
				}
				inner = inner + "</select>";
				document.getElementById("combobox_" + name).innerHTML = inner;
				
				// Cap resultat, sinó es mostraria 'undefined'
				if (xmlDoc.getElementsByTagName("element").length == 0) {
					document.getElementById("combobox_" + name).innerHTML="<select name=\"combobox_" + name + "_ajax\"><option value='-1'><?=_('No hi ha coincidències')?></option></select>";
				}
			} else {
				document.getElementById("combobox_" + name).innerHTML="<select name=\"combobox_" + name + "_ajax\"><option value='-1'><?=_('Carregant dades...')?></option></select>";
			}
		};
		xmlHttp.send();
	}
	
	// Funció que transformar la string de l'arxiu ajax a format XML
	function loadXMLString(txt) {
		if (window.DOMParser) {
			parser = new DOMParser();
			xmlDoc = parser.parseFromString(txt,"text/xml");
		} else { // Internet Explorer
			try {
				var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
				xmlDoc.async = false;
				xmlDoc.loadXML(txt);
			} catch(ex) { 
				alert(ex.message); 
			}
		}
		return xmlDoc;
	}

</script>